gtkmm: Gtk::Window Class Reference

gtkmm 2.24.5

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gtk::Window Class Reference
Widgets

Toplevel Window This represents all widgets which are physical windows controlled by the window manager. More...

Inheritance diagram for Gtk::Window:
[legend]
Collaboration diagram for Gtk::Window:
[legend]

## Public Member Functions
virtual | ~Window ()
GtkWindow* | gobj ()
| Provides access to the underlying C GtkObject. More...
const GtkWindow* | gobj () const
| Provides access to the underlying C GtkObject. More...
| Window (WindowType type=WINDOW_TOPLEVEL)
Glib::PropertyProxy_ReadOnly< WindowType > | property_type () const
| The type of the window. More...
Glib::PropertyProxy< Glib::ustring > | property_title ()
| The title of the window. More...
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_title () const
| The title of the window. More...
Glib::PropertyProxy_WriteOnly< Glib::ustring > | property_startup_id ()
| Unique startup identifier for the window used by startup-notification. More...
Glib::PropertyProxy< bool > | property_allow_shrink ()
| If TRUE, the window has no mimimum size. More...
Glib::PropertyProxy_ReadOnly< bool > | property_allow_shrink () const
| If TRUE, the window has no mimimum size. More...
Glib::PropertyProxy< bool > | property_allow_grow ()
| If TRUE, users can expand the window beyond its minimum size. More...
Glib::PropertyProxy_ReadOnly< bool > | property_allow_grow () const
| If TRUE, users can expand the window beyond its minimum size. More...
Glib::PropertyProxy< bool > | property_resizable ()
| If TRUE, users can resize the window. More...
Glib::PropertyProxy_ReadOnly< bool > | property_resizable () const
| If TRUE, users can resize the window. More...
Glib::PropertyProxy< bool > | property_modal ()
| If TRUE, the window is modal (other windows are not usable while this one is up). More...
Glib::PropertyProxy_ReadOnly< bool > | property_modal () const
| If TRUE, the window is modal (other windows are not usable while this one is up). More...
Glib::PropertyProxy< WindowPosition > | property_window_position ()
| The initial position of the window. More...
Glib::PropertyProxy_ReadOnly< WindowPosition > | property_window_position () const
| The initial position of the window. More...
Glib::PropertyProxy< int > | property_default_width ()
| The default width of the window, used when initially showing the window. More...
Glib::PropertyProxy_ReadOnly< int > | property_default_width () const
| The default width of the window, used when initially showing the window. More...
Glib::PropertyProxy< int > | property_default_height ()
| The default height of the window, used when initially showing the window. More...
Glib::PropertyProxy_ReadOnly< int > | property_default_height () const
| The default height of the window, used when initially showing the window. More...
Glib::PropertyProxy< bool > | property_destroy_with_parent ()
| If this window should be destroyed when the parent is destroyed. More...
Glib::PropertyProxy_ReadOnly< bool > | property_destroy_with_parent () const
| If this window should be destroyed when the parent is destroyed. More...
Glib::PropertyProxy< Glib::RefPtr< Gdk::Pixbuf > > | property_icon ()
| Icon for this window. More...
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Gdk::Pixbuf > > | property_icon () const
| Icon for this window. More...
Glib::PropertyProxy< bool > | property_mnemonics_visible ()
| Whether mnemonics are currently visible in this window. More...
Glib::PropertyProxy_ReadOnly< bool > | property_mnemonics_visible () const
| Whether mnemonics are currently visible in this window. More...
Glib::PropertyProxy< Glib::ustring > | property_icon_name ()
| Name of the themed icon for this window. More...
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_icon_name () const
| Name of the themed icon for this window. More...
Glib::PropertyProxy< Glib::RefPtr< Gdk::Screen > > | property_screen ()
| The screen where this window will be displayed. More...
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Gdk::Screen > > | property_screen () const
| The screen where this window will be displayed. More...
Glib::PropertyProxy_ReadOnly< bool > | property_is_active () const
| Whether the toplevel is the current active window. More...
Glib::PropertyProxy_ReadOnly< bool > | property_has_toplevel_focus () const
| Whether the input focus is within this GtkWindow. More...
Glib::PropertyProxy< GdkWindowTypeHint > | property_type_hint ()
| Hint to help the desktop environment understand what kind of window this is and how to treat it. More...
Glib::PropertyProxy_ReadOnly< GdkWindowTypeHint > | property_type_hint () const
| Hint to help the desktop environment understand what kind of window this is and how to treat it. More...
Glib::PropertyProxy< bool > | property_skip_taskbar_hint ()
| TRUE if the window should not be in the task bar. More...
Glib::PropertyProxy_ReadOnly< bool > | property_skip_taskbar_hint () const
| TRUE if the window should not be in the task bar. More...
Glib::PropertyProxy< bool > | property_skip_pager_hint ()
| TRUE if the window should not be in the pager. More...
Glib::PropertyProxy_ReadOnly< bool > | property_skip_pager_hint () const
| TRUE if the window should not be in the pager. More...
Glib::PropertyProxy< Glib::ustring > | property_role ()
| Unique identifier for the window to be used when restoring a session. More...
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_role () const
| Unique identifier for the window to be used when restoring a session. More...
Glib::PropertyProxy< bool > | property_decorated ()
| Whether the window should be decorated by the window manager. More...
Glib::PropertyProxy_ReadOnly< bool > | property_decorated () const
| Whether the window should be decorated by the window manager. More...
Glib::PropertyProxy< Gdk::Gravity > | property_gravity ()
| The window gravity of the window. More...
Glib::PropertyProxy_ReadOnly< Gdk::Gravity > | property_gravity () const
| The window gravity of the window. More...
Glib::PropertyProxy< Window*> | property_transient_for ()
| The transient parent of the dialog. More...
Glib::PropertyProxy_ReadOnly< Window*> | property_transient_for () const
| The transient parent of the dialog. More...
Glib::PropertyProxy< double > | property_opacity ()
| The opacity of the window, from 0 to 1. More...
Glib::PropertyProxy_ReadOnly< double > | property_opacity () const
| The opacity of the window, from 0 to 1. More...
Glib::PropertyProxy< bool > | property_urgency_hint ()
| TRUE if the window should be brought to the user's attention. More...
Glib::PropertyProxy_ReadOnly< bool > | property_urgency_hint () const
| TRUE if the window should be brought to the user's attention. More...
Glib::PropertyProxy< bool > | property_accept_focus ()
| TRUE if the window should receive the input focus. More...
Glib::PropertyProxy_ReadOnly< bool > | property_accept_focus () const
| TRUE if the window should receive the input focus. More...
Glib::PropertyProxy< bool > | property_focus_on_map ()
| TRUE if the window should receive the input focus when mapped. More...
Glib::PropertyProxy_ReadOnly< bool > | property_focus_on_map () const
| TRUE if the window should receive the input focus when mapped. More...
Glib::PropertyProxy< bool > | property_deletable ()
| Whether the window frame should have a close button. More...
Glib::PropertyProxy_ReadOnly< bool > | property_deletable () const
| Whether the window frame should have a close button. More...
bool | is_toplevel () const
bool | is_popup () const
Glib::RefPtr< Gdk::Window > | get_frame ()
Glib::RefPtr< const Gdk::Window > | get_frame () const
Glib::SignalProxy< void, Widget*> | signal_set_focus ()
Glib::SignalProxy< bool, GdkEvent*> | signal_frame_event ()
void | set_title (const Glib::ustring& title)
| Sets the title of the Gtk::Window. More...
Glib::ustring | get_title () const
| Retrieves the title of the window. More...
void | set_wmclass (const Glib::ustring& wmclass_name, const Glib::ustring& wmclass_class)
| Don't use this function. More...
void | set_role (const Glib::ustring& role)
| This function is only useful on X11, not with other GTK+ targets. More...
Glib::ustring | get_role () const
| Returns the role of the window. More...
void | add_accel_group (const Glib::RefPtr< AccelGroup >& accel_group)
| Associate accel_group with window, such that calling gtk_accel_groups_activate() on window will activate accelerators in accel_group. More...
void | remove_accel_group (const Glib::RefPtr< AccelGroup >& accel_group)
| Reverses the effects of add_accel_group(). More...
void | set_position (WindowPosition position)
| Sets a position constraint for this window. More...
bool | activate_focus ()
| Activates the current focused widget within the window. More...
void | set_focus (Gtk::Widget& focus)
| If focus is not the current focus widget, and is focusable, sets it as the focus widget for the window. More...
void | unset_focus ()
Widget* | get_focus ()
| Retrieves the current focused widget within the window. More...
const Widget* | get_focus () const
| Retrieves the current focused widget within the window. More...
void | set_default (Gtk::Widget& default_widget)
| The default widget is the widget that's activated when the user presses Enter in a dialog (for example). More...
void | unset_default ()
bool | activate_default ()
| Activates the default widget for the window, unless the current focused widget has been configured to receive the default action (see Gtk::Widget::set_receives_default()), in which case the focused widget is activated. More...
void | set_transient_for (Window& parent)
| Dialog windows should be set transient for the main application window they were spawned from. More...
void | unset_transient_for ()
| Unsets the current transient window. More...
Window* | get_transient_for ()
| Fetches the transient parent for this window. More...
const Window* | get_transient_for () const
| Fetches the transient parent for this window. More...
void | set_opacity (double opacity)
| Request the windowing system to make window partially transparent, with opacity 0 being fully transparent and 1 fully opaque. More...
double | get_opacity () const
| Fetches the requested opacity for this window. More...
void | set_type_hint (Gdk::WindowTypeHint hint)
| By setting the type hint for the window, you allow the window manager to decorate and handle the window in a way which is suitable to the function of the window in your application. More...
Gdk::WindowTypeHint | get_type_hint () const
| Gets the type hint for this window. More...
void | set_skip_taskbar_hint (bool setting=true)
| Windows may set a hint asking the desktop environment not to display the window in the task bar. More...
bool | get_skip_taskbar_hint () const
| Gets the value set by set_skip_taskbar_hint() More...
void | set_skip_pager_hint (bool setting=true)
| Windows may set a hint asking the desktop environment not to display the window in the pager. More...
bool | get_skip_pager_hint () const
| Gets the value set by set_skip_pager_hint(). More...
void | set_urgency_hint (bool setting=true)
| Windows may set a hint asking the desktop environment to draw the users attention to the window. More...
bool | get_urgency_hint () const
| Gets the value set by set_urgency_hint() More...
void | set_accept_focus (bool setting=true)
| Windows may set a hint asking the desktop environment not to receive the input focus. More...
bool | get_accept_focus () const
| Gets the value set by set_accept_focus(). More...
void | set_focus_on_map (bool setting=true)
| Windows may set a hint asking the desktop environment not to receive the input focus when the window is mapped. More...
bool | get_focus_on_map () const
| Gets the value set by set_focus_on_map(). More...
bool | get_destroy_with_parent () const
| Returns whether the window will be destroyed with its transient parent. More...
void | set_mnemonics_visible (bool setting=true)
| Sets the Gtk::Window::property_mnemonics_visible() property. More...
bool | get_mnemonics_visible () const
void | set_resizable (bool resizable=true)
| Sets whether the user can resize a window. More...
bool | get_resizable () const
| Gets the value set by set_resizable(). More...
void | set_gravity (Gdk::Gravity gravity)
| Window gravity defines the meaning of coordinates passed to move(). More...
Gdk::Gravity | get_gravity () const
| Gets the value set by set_gravity(). More...
void | set_geometry_hints (Widget& geometry_widget, const Gdk::Geometry& geometry, Gdk::WindowHints geom_mask)
| This function sets up hints about how a window can be resized by the user. More...
void | set_screen (const Glib::RefPtr< Gdk::Screen >& screen)
| Sets the Gdk::Screen where the window is displayed; if the window is already mapped, it will be unmapped, and then remapped on the new screen. More...
Glib::RefPtr< Gdk::Screen > | get_screen ()
| Returns the Gdk::Screen associated with window. More...
Glib::RefPtr< const Gdk::Screen > | get_screen () const
| Returns the Gdk::Screen associated with window. More...
void | set_has_frame (bool setting=true)
| (Note: this is a special-purpose function for the framebuffer port, that causes GTK+ to draw its own window border. More...
bool | get_has_frame () const
| Accessor for whether the window has a frame window exterior to window->window. More...
void | set_frame_dimensions (int left, int top, int right, int bottom)
| (Note: this is a special-purpose function intended for the framebuffer port; see set_has_frame(). More...
void | get_frame_dimensions (int&left, int& top, int&right, int& bottom) const
| (Note: this is a special-purpose function intended for the framebuffer port; see set_has_frame(). More...
void | set_decorated (bool setting=true)
| By default, windows are decorated with a title bar, resize controls, etc. More...
bool | get_decorated () const
| Returns whether the window has been set to have decorations such as a title bar via set_decorated(). More...
void | set_deletable (bool setting=true)
| By default, windows have a close button in the window frame. More...
bool | get_deletable () const
| Returns whether the window has been set to have a close button via set_deletable(). More...
Glib::ListHandle< Glib::RefPtr< Gdk::Pixbuf > > | get_icon_list ()
| Retrieves the list of icons set by set_icon_list(). More...
Glib::ListHandle< Glib::RefPtr< const Gdk::Pixbuf > > | get_icon_list () const
| Retrieves the list of icons set by set_icon_list(). More...
void | set_icon_list (const Glib::ListHandle< Glib::RefPtr< Gdk::Pixbuf > >& list)
| Sets up the icon representing a Gtk::Window. More...
void | set_icon (const Glib::RefPtr< Gdk::Pixbuf >& icon)
| Sets up the icon representing a Gtk::Window. More...
void | set_icon_name (const Glib::ustring& name)
| Sets the icon for the window from a named themed icon. More...
bool | set_icon_from_file (const std::string& filename)
| Sets the icon for the window. More...
Glib::RefPtr< Gdk::Pixbuf > | get_icon ()
| Gets the value set by set_icon() (or if you've called set_icon_list(), gets the first icon in the icon list). More...
Glib::RefPtr< const Gdk::Pixbuf > | get_icon () const
| Gets the value set by set_icon() (or if you've called set_icon_list(), gets the first icon in the icon list). More...
Glib::ustring | get_icon_name () const
| Returns the name of the themed icon for the window, see set_icon_name(). More...
void | set_modal (bool modal=true)
| Sets a window modal or non-modal. More...
bool | get_modal () const
| Returns whether the window is modal. More...
void | add_mnemonic (guint keyval, Widget& target)
| Adds a mnemonic to this window. More...
void | remove_mnemonic (guint keyval, Widget& target)
| Removes a mnemonic from this window. More...
bool | mnemonic_activate (guint keyval, Gdk::ModifierType modifier)
| Activates the targets associated with the mnemonic. More...
void | set_mnemonic_modifier (Gdk::ModifierType modifier)
| Sets the mnemonic modifier for this window. More...
Gdk::ModifierType | get_mnemonic_modifier ()
| Returns the mnemonic modifier for this window. More...
void | present ()
| Presents a window to the user. More...
void | present (guint32 timestamp)
| Presents a window to the user in response to a user interaction. More...
void | iconify ()
| Asks to iconify (i.e. minimize) the specified window. More...
void | deiconify ()
| Asks to deiconify (i.e. unminimize) the specified window. More...
void | stick ()
| Asks to stick window, which means that it will appear on all user desktops. More...
void | unstick ()
| Asks to unstick window, which means that it will appear on only one of the user's desktops. More...
void | maximize ()
| Asks to maximize window, so that it becomes full-screen. More...
void | unmaximize ()
| Asks to unmaximize window. More...
void | fullscreen ()
| Asks to place window in the fullscreen state. More...
void | unfullscreen ()
| Asks to toggle off the fullscreen state for window. More...
void | begin_resize_drag (Gdk::WindowEdge edge, int button, int root_x, int root_y, guint32 timestamp)
| Starts resizing a window. More...
void | begin_move_drag (int button, int root_x, int root_y, guint32 timestamp)
| Starts moving a window. More...
void | set_default_size (int width, int height)
| Sets the default size of a window. More...
void | get_default_size (int& width, int& height) const
| Gets the default size of the window. More...
void | resize (int width, int height)
| Resizes the window as if the user had done so, obeying geometry constraints. More...
void | get_size (int& width, int& height) const
| Obtains the current size of window. More...
void | move (int x, int y)
| Asks the window manager to move window to the given position. More...
void | get_position (int& root_x, int& root_y) const
| This function returns the position you need to pass to move() to keep window in its current position. More...
bool | parse_geometry (const Glib::ustring& geometry)
| Parses a standard X Window System geometry string - see the manual page for X (type 'man X') for details on this. More...
Glib::RefPtr< WindowGroup > | get_group ()
| Returns the group for window or the default group, if window is `nullptr` or if window does not have an explicit window group. More...
Glib::RefPtr< const WindowGroup > | get_group () const
| Returns the group for window or the default group, if window is `nullptr` or if window does not have an explicit window group. More...
WindowType | get_window_type () const
| Gets the type of the window. More...
void | reshow_with_initial_size ()
| Hides window, then reshows it, resetting the default size and position of the window. More...
void | set_keep_above (bool setting=true)
| Asks to keep window above, so that it stays on top. More...
void | set_keep_below (bool setting=true)
| Asks to keep window below, so that it stays in bottom. More...
Glib::RefPtr< AccelGroup > | get_accel_group ()
| Returns a default accel group for this window This is a gtkmm-specific function. More...
virtual void | raise ()
| Brings the window to the front. More...
virtual void | set_manage ()
| Overriden to warn that it doesn't make sense to use Gtk::manage() on this class because it has no parent container. More...
Public Member Functions inherited from Gtk::Bin
virtual | ~Bin ()
GtkBin* | gobj ()
| Provides access to the underlying C GtkObject. More...
const GtkBin* | gobj () const
| Provides access to the underlying C GtkObject. More...
Gtk::Widget* | get_child ()
| Gets the child of the Gtk::Bin, or `nullptr` if the bin contains no child widget. More...
const Gtk::Widget* | get_child () const
| Gets the child of the Gtk::Bin, or `nullptr` if the bin contains no child widget. More...
void | remove ()
| Remove the contained object Since this can only hold one object it is not necessary to specify which object to remove like other containers. More...
void | add_label (const Glib::ustring& label, bool mnemonic=false, double x_align=0.5, double y_align=0.5)
| Add a Label object. More...
void | add_label (const Glib::ustring& label, bool mnemonic, AlignmentEnum x_align, AlignmentEnum y_align=ALIGN_CENTER)
| Add a Label object. More...
void | add_pixmap (const Glib::RefPtr< Gdk::Pixmap >& pixmap, const Glib::RefPtr< Gdk::Bitmap >& mask)
| Add an Image object. More...
void | add_pixlabel (const Glib::RefPtr< Gdk::Pixmap >& pixmap, const Glib::RefPtr< Gdk::Bitmap >& mask, const Glib::ustring& label, double x_align=0.5, double y_align=0.5)
| Add Image and Label objects. More...
void | add_pixlabel (const Glib::ustring& pixfile, const Glib::ustring& label, double x_align=0.5, double y_align=0.5)
| Add Image and Label objects. More...
Public Member Functions inherited from Gtk::Container
virtual | ~Container ()
GtkContainer* | gobj ()
| Provides access to the underlying C GtkObject. More...
const GtkContainer* | gobj () const
| Provides access to the underlying C GtkObject. More...
void | set_border_width (guint border_width)
| Sets the border width of the container. More...
guint | get_border_width () const
| Retrieves the border width of the container. More...
virtual void | add (Widget& widget)
void | remove (Widget& widget)
| Removes widget from container. More...
void | set_resize_mode (ResizeMode resize_mode)
| Sets the resize mode for the container. More...
ResizeMode | get_resize_mode () const
| Returns the resize mode for the container. More...
void | check_resize ()
| Request that contained widgets check their size. More...
void | foreach (const ForeachSlot& slot)
| Operate on contained items This is largely an internal used mainly for things like creating duplicates of internal lists and other such operations. More...
Glib::ListHandle< Widget* > | get_children ()
| (internal) Operate on contained items (see foreach()) More...
Glib::ListHandle< const Widget* > | get_children () const
| Returns the container's non-internal children. More...
void | propagate_expose (Widget& child, GdkEventExpose*event)
| When a container receives an expose event, it must send synthetic expose events to all children that don't have their own Gdk::Windows. More...
void | set_focus_chain (const Glib::ListHandle< Widget*>& focusable_widgets)
| Sets a focus chain, overriding the one computed automatically by GTK+. More...
bool | has_focus_chain () const
Glib::ListHandle< Widget* > | get_focus_chain ()
Glib::ListHandle< const Widget* > | get_focus_chain () const
void | unset_focus_chain ()
| Removes a focus chain explicitly set with set_focus_chain(). More...
void | set_reallocate_redraws (bool needs_redraws=true)
| Sets the reallocate_redraws flag of the container to the given value. More...
void | set_focus_child (Widget& widget)
| Sets the focus on a child. More...
void | set_focus_vadjustment (Adjustment& adjustment)
| Hooks up an adjustment to focus handling in a container, so when a child of the container is focused, the adjustment is scrolled to show that widget. More...
Adjustment* | get_focus_vadjustment ()
| Retrieves the vertical focus adjustment for the container. More...
const Adjustment* | get_focus_vadjustment () const
| Retrieves the vertical focus adjustment for the container. More...
void | set_focus_hadjustment (Adjustment& adjustment)
| Hooks up an adjustment to focus handling in a container, so when a child of the container is focused, the adjustment is scrolled to show that widget. More...
Adjustment* | get_focus_hadjustment ()
| Retrieves the horizontal focus adjustment for the container. More...
const Adjustment* | get_focus_hadjustment () const
| Retrieves the horizontal focus adjustment for the container. More...
void | resize_children ()
GType | child_type () const
| Returns the type of the children supported by the container. More...
Glib::SignalProxy< void, Widget*> | signal_add ()
Glib::SignalProxy< void, Widget*> | signal_remove ()
Glib::SignalProxy< void > | signal_check_resize ()
Glib::SignalProxy< void, Widget*> | signal_set_focus_child ()
void | show_all_children (bool recursive=true)
Public Member Functions inherited from Gtk::Widget
virtual | ~Widget ()
GtkWidget* | gobj ()
| Provides access to the underlying C GtkObject. More...
const GtkWidget* | gobj () const
| Provides access to the underlying C GtkObject. More...
bool | set_scroll_adjustments (Adjustment& hadjustment, Adjustment& vadjustment)
| For widgets that support scrolling, sets the scroll adjustments and returns `true`. More...
void | show ()
| Flags a widget to be displayed. More...
void | show_now ()
| Shows a widget. More...
void | hide ()
| Reverses the effects of show(), causing the widget to be hidden (invisible to the user). More...
void | show_all ()
| Recursively shows a widget, and any child widgets (if the widget is a container). More...
void | hide_all ()
| Recursively hides a widget and any child widgets. More...
void | queue_draw ()
| Equivalent to calling queue_draw_area() for the entire area of a widget. More...
void | queue_draw_area (int x, int y, int width, int height)
| Invalidates the rectangular area of widget defined by x, y, width and height by calling gdk_window_invalidate_rect() on the widget's window and all its child windows. More...
void | queue_resize ()
| This function is only for use in widget implementations. More...
Requisition | size_request () const
| This function is typically used when implementing a Gtk::Container subclass. More...
void | size_request (const Requisition& requisition)
| This function is typically used when implementing a Gtk::Container subclass. More...
void | size_allocate (const Allocation& allocation)
| This function is only used by Gtk::Container subclasses, to assign a size and position to their child widgets. More...
void | add_accelerator (const Glib::ustring& accel_signal, const Glib::RefPtr< AccelGroup >& accel_group, guint accel_key, Gdk::ModifierType accel_mods, AccelFlags accel_flags)
| Installs an accelerator for this widget in accel_group that causes accel_signal to be emitted if the accelerator is activated. More...
bool | remove_accelerator (const Glib::RefPtr< AccelGroup >& accel_group, guint accel_key, Gdk::ModifierType accel_mods)
| Removes an accelerator from widget, previously installed with add_accelerator(). More...
void | set_accel_path (const Glib::ustring& accel_path, const Glib::RefPtr< AccelGroup >& accel_group)
| Given an accelerator group, accel_group, and an accelerator path, accel_path, sets up an accelerator in accel_group so whenever the key binding that is defined for accel_path is pressed, widget will be activated. More...
bool | mnemonic_activate (bool group_cycling)
| Emits the Gtk::Widget::signal_mnemonic_activate() signal. More...
bool | event (GdkEvent* event)
| Rarely-used function. More...
int | send_expose (GdkEvent*event)
| Very rarely-used function. More...
bool | send_focus_change (GdkEvent*event)
| Sends the focus change event to widget. More...
bool | activate ()
| For widgets that can be "activated" (buttons, menu items, etc.) this function activates them. More...
void | reparent (Widget& new_parent)
| Moves a widget from one Gtk::Container to another, handling reference count issues to avoid destroying the widget. More...
bool | intersect (const Gdk::Rectangle& area) const
bool | intersect (const Gdk::Rectangle& area, Gdk::Rectangle& intersection) const
| Computes the intersection of a widget's area and area, storing the intersection in intersection, and returns `true` if there was an intersection. More...
Gdk::Region | region_intersect (const Gdk::Region& region) const
| Computes the intersection of a widget's area and region, returning the intersection. More...
void | freeze_child_notify ()
| Stops emission of Gtk::Widget::signal_child_notify() signals on widget. More...
void | child_notify (const Glib::ustring& child_property)
| Emits a Gtk::Widget::signal_child_notify() signal for the child property child_property on widget. More...
void | thaw_child_notify ()
| Reverts the effect of a previous call to freeze_child_notify(). More...
void | set_can_focus (bool can_focus=true)
| Specifies whether widget can own the input focus. More...
bool | get_can_focus () const
| Determines whether widget can own the input focus. More...
bool | can_focus () const
| Determines whether widget can own the input focus. More...
bool | has_focus () const
| Determines if the widget has the global input focus. More...
bool | is_focus () const
| Determines if the widget is the focus widget within its toplevel. More...
void | grab_focus ()
| Causes widget to have the keyboard focus for the Gtk::Window it's inside. More...
void | set_can_default (bool can_default=true)
| Specifies whether widget can be a default widget. More...
bool | get_can_default () const
| Determines whether widget can be a default widget. More...
bool | can_default () const
| Determines whether widget can be a default widget. More...
bool | has_default () const
| Determines whether widget is the current default widget within its toplevel. More...
void | grab_default ()
| Causes widget to become the default widget. More...
void | set_receives_default (bool receives_default=true)
| Specifies whether widget will be treated as the default widget within its toplevel when it has the focus, even if another widget is the default. More...
bool | get_receives_default () const
| Determines whether widget is alyways treated as default widget withing its toplevel when it has the focus, even if another widget is the default. More...
bool | has_grab () const
| Determines whether the widget is currently grabbing events, so it is the only widget receiving input events (keyboard and mouse). More...
void | add_modal_grab ()
| Block events to everything else than this widget and its children. More...
void | remove_modal_grab ()
| Remove the modal grab of the widget in case it was previously grabbed. More...
void | set_name (const Glib::ustring& name)
| Widgets can be named, which allows you to refer to them from a gtkrc file. More...
void | unset_name ()
Glib::ustring | get_name () const
| Retrieves the name of a widget. More...
void | set_state (StateType state)
| This function is for use in widget implementations. More...
StateType | get_state () const
| Returns the widget's state. More...
void | set_sensitive (bool sensitive=true)
| Sets the sensitivity of a widget. More...
bool | get_sensitive () const
| Returns the widget's sensitivity (in the sense of returning the value that has been set using set_sensitive()). More...
bool | is_sensitive () const
| Returns the widget's effective sensitivity, which means it is sensitive itself and also its parent widget is sensntive. More...
void | set_visible (bool visible=true)
| Sets the visibility state of widget. More...
bool | get_visible () const
| Determines whether the widget is visible. More...
void | set_has_window (bool has_window=true)
| Specifies whether widget has a Gdk::Window of its own. More...
bool | get_has_window () const
| Determines whether widget has a Gdk::Window of its own. More...
bool | get_is_toplevel () const
| Determines whether widget is a toplevel widget. More...
bool | get_is_drawable () const
| Determines whether widget can be drawn to. More...
bool | get_realized () const
| Determines whether widget is realized. More...
bool | get_mapped () const
| Whether the widget is mapped. More...
void | set_app_paintable (bool app_paintable=true)
| Sets whether the application intends to draw on the widget in an Gtk::Widget::signal_expose_event() handler. More...
bool | get_app_paintable () const
| Determines whether the application intends to draw on the widget in an Gtk::Widget::signal_expose_event() handler. More...
void | set_double_buffered (bool double_buffered=true)
| Widgets are double buffered by default; you can use this function to turn off the buffering. More...
bool | get_double_buffered () const
| Determines whether the widget is double buffered. More...
void | set_redraw_on_allocate (bool redraw_on_allocate=true)
| Sets whether the entire widget is queued for drawing when its size allocation changes. More...
void | set_child_visible (bool is_visible=true)
| Sets whether widget should be mapped along with its when its parent is mapped and widget has been shown with show(). More...
bool | get_child_visible () const
| Gets the value set with set_child_visible(). More...
void | set_window (const Glib::RefPtr< Gdk::Window >& window)
| Sets a widget's window. More...
Glib::RefPtr< Gdk::Window > | get_window ()
| Returns the widget's window if it is realized, `nullptr` otherwise. More...
Glib::RefPtr< const Gdk::Window > | get_window () const
| Returns the widget's window if it is realized, `nullptr` otherwise. More...
Allocation | get_allocation () const
| Retrieves the widget's location. More...
void | set_allocation (const Allocation& allocation)
| Sets the widget's allocation. More...
Container* | get_parent ()
| Returns the parent container of widget. More...
const Container* | get_parent () const
| Returns the parent container of widget. More...
Glib::RefPtr< Gdk::Window > | get_parent_window ()
| Gets widget's parent window. More...
Glib::RefPtr< const Gdk::Window > | get_parent_window () const
| Gets widget's parent window. More...
void | set_parent_window (const Glib::RefPtr< const Gdk::Window >& parent_window)
| Sets a non default parent window for widget. More...
bool | child_focus (DirectionType direction)
| This function is used by custom widget implementations; if you're writing an app, you'd use grab_focus() to move the focus to a particular widget, and Gtk::Container::set_focus_chain() to change the focus tab order. More...
bool | keynav_failed (DirectionType direction)
| This function should be called whenever keyboard navigation within a single widget hits a boundary. More...
void | error_bell ()
| Notifies the user about an input-related error on this widget. More...
void | set_size_request (int width=-1, int height=-1)
| Sets the minimum size of a widget; that is, the widget's size request will be width by height. More...
void | get_size_request (int& width, int& height) const
| Gets the size request that was explicitly set for the widget using set_size_request(). More...
void | set_events (Gdk::EventMask events)
| Sets the event mask (see Gdk::EventMask) for a widget. More...
void | add_events (Gdk::EventMask events)
| Adds the events in the bitfield events to the event mask for widget. More...
void | set_extension_events (Gdk::ExtensionMode mode)
| Sets the extension events mask to mode. More...
Gdk::ExtensionMode | get_extension_events () const
| Retrieves the extension events the widget will receive; see gdk_input_set_extension_events(). More...
Container* | get_toplevel ()
| This function returns the topmost widget in the container hierarchy widget is a part of. More...
const Container* | get_toplevel () const
| This function returns the topmost widget in the container hierarchy widget is a part of. More...
Widget* | get_ancestor (GType widget_type)
| Gets the first ancestor of widget with type widget_type. More...
const Widget* | get_ancestor (GType widget_type) const
| Gets the first ancestor of widget with type widget_type. More...
Glib::RefPtr< Gdk::Colormap > | get_colormap ()
| Gets the colormap that will be used to render widget. More...
Glib::RefPtr< Gdk::Visual > | get_visual ()
| Gets the visual that will be used to render widget. More...
Glib::RefPtr< Gdk::Screen > | get_screen ()
| Get the Gdk::Screen from the toplevel window associated with this widget. More...
Glib::RefPtr< const Gdk::Screen > | get_screen () const
| Get the Gdk::Screen from the toplevel window associated with this widget. More...
bool | has_screen () const
| Checks whether there is a Gdk::Screen is associated with this widget. More...
Glib::RefPtr< Gdk::Display > | get_display ()
| Get the Gdk::Display for the toplevel window associated with this widget. More...
Glib::RefPtr< const Gdk::Display > | get_display () const
| Get the Gdk::Display for the toplevel window associated with this widget. More...
Glib::RefPtr< Gdk::Window > | get_root_window ()
| Get the root window where this widget is located. More...
Glib::RefPtr< const Gdk::Window > | get_root_window () const
| Get the root window where this widget is located. More...
Glib::RefPtr< Settings > | get_settings ()
| Gets the settings object holding the settings (global property settings, RC file information, etc) used for this widget. More...
Glib::RefPtr< Clipboard > | get_clipboard (const Glib::ustring& selection)
| Returns the clipboard object for the given selection to be used with widget. More...
Glib::RefPtr< const Clipboard > | get_clipboard (const Glib::ustring& selection) const
| Returns the clipboard object for the given selection to be used with widget. More...
Glib::RefPtr< Gdk::Pixmap > | get_snapshot (Gdk::Rectangle& clip_rect) const
| Create a Gdk::Pixmap of the contents of the widget and its children. More...
Glib::RefPtr< Gdk::Pixmap > | get_snapshot () const
| Create a Gdk::Pixmap of the contents of the widget and its children. More...
Glib::RefPtr< Atk::Object > | get_accessible ()
| Returns the accessible object that describes the widget to an assistive technology. More...
Glib::RefPtr< const Atk::Object > | get_accessible () const
| Returns the accessible object that describes the widget to an assistive technology. More...
void | set_colormap (const Glib::RefPtr< const Gdk::Colormap >& colormap)
| Sets the colormap for the widget to the given value. More...
Gdk::EventMask | get_events () const
| Returns the event mask for the widget (a bitfield containing flags from the Gdk::EventMask enumeration). More...
void | get_pointer (int& x, int& y) const
| Obtains the location of the mouse pointer in widget coordinates. More...
bool | is_ancestor (Widget& ancestor) const
| Determines whether widget is somewhere inside ancestor, possibly with intermediate containers. More...
bool | translate_coordinates (Widget& dest_widget, int src_x, int src_y, int& dest_x, int& dest_y)
| Translate coordinates relative to src_widget's allocation to coordinates relative to dest_widget's allocations. More...
bool | has_rc_style () const
| Determines if the widget style has been looked up through the rc mechanism. More...
void | set_style (const Glib::RefPtr< Style >& style)
| Sets the Gtk::Style for a widget ( widget->style). More...
void | unset_style ()
void | ensure_style ()
| Ensures that widget has a style ( widget->style). More...
Glib::RefPtr< Style > | get_style ()
| Simply an accessor function that returns widget->style. More...
Glib::RefPtr< const Style > | get_style () const
| Simply an accessor function that returns widget->style. More...
void | modify_style (const Glib::RefPtr< RcStyle >& style)
| Modifies style values on the widget. More...
Glib::RefPtr< RcStyle > | get_modifier_style ()
| Returns the current modifier style for the widget. More...
Glib::RefPtr< const RcStyle > | get_modifier_style () const
| Returns the current modifier style for the widget. More...
void | modify_fg (StateType state, const Gdk::Color& color)
| Sets the foreground color for a widget in a particular state. More...
void | modify_bg (StateType state, const Gdk::Color& color)
| Sets the background color for a widget in a particular state. More...
void | modify_bg_pixmap (StateType state, const Glib::ustring& pixmap_name)
void | modify_text (StateType state, const Gdk::Color& color)
| Sets the text color for a widget in a particular state. More...
void | modify_base (StateType state, const Gdk::Color& color)
| Sets the base color for a widget in a particular state. More...
void | modify_cursor (const Gdk::Color& primary, const Gdk::Color& secondary)
| Sets the cursor color to use in a widget, overriding the cursor_color and secondary_cursor_color style properties. More...
void | unset_cursor ()
| See modify_cursor(). More...
void | modify_font (const Pango::FontDescription& font_desc)
| Sets the font to use for a widget. More...
void | unset_fg (StateType state)
| Undo the effect of previous calls to modify_fg() for a particular state. More...
void | unset_bg (StateType state)
| Undo the effect of previous calls to modify_bg() for a particular state. More...
void | unset_text (StateType state)
| Undo the effect of previous calls to modify_text() for a particular state. More...
void | unset_base (StateType state)
| Undo the effect of previous calls to modify_base() for a particular state. More...
void | unset_font ()
| Undo the effect of previous calls to modify_font() for a particular state. More...
template<class PropertyType >
void | get_style_property (const Glib::ustring& the_property_name, PropertyType& value) const
Glib::RefPtr< Pango::Context > | create_pango_context ()
| Creates a new Pango::Context with the appropriate font map, font description, and base direction for drawing text for this widget. More...
Glib::RefPtr< Pango::Context > | get_pango_context ()
| Gets a Pango::Context with the appropriate font map, font description, and base direction for this widget. More...
Glib::RefPtr< Pango::Layout > | create_pango_layout (const Glib::ustring& text)
| Creates a new Pango::Layout with the appropriate font map, font description, and base direction for drawing text for this widget. More...
Glib::RefPtr< Gdk::Pixbuf > | render_icon (const StockID& stock_id, IconSize size, const Glib::ustring& detail=Glib::ustring())
| A convenience function that uses the theme engine and RC file settings for the widget to look up stock_id and render it to a pixbuf. More...
void | set_composite_name (const Glib::ustring& name)
| Sets a widgets composite name. More...
void | unset_composite_name ()
Glib::ustring | get_composite_name () const
| Obtains the composite name of a widget. More...
void | reset_rc_styles ()
| Reset the styles of widget and all descendents, so when they are looked up again, they get the correct values for the currently loaded RC file settings. More...
void | set_direction (TextDirection dir)
| Sets the reading direction on a particular widget. More...
TextDirection | get_direction ()
| Gets the reading direction for a particular widget. More...
TextDirection | get_direction () const
| Gets the reading direction for a particular widget. More...
void | shape_combine_mask (const Glib::RefPtr< const Gdk::Bitmap >& shape_mask, int offset_x, int offset_y)
| Sets a shape for this widget's GDK window. More...
void | unset_shape_combine_mask ()
void | input_shape_combine_mask (const Glib::RefPtr< const Gdk::Bitmap >& shape_mask, int offset_x, int offset_y)
| Sets an input shape for this widget's GDK window. More...
void | unset_input_shape_combine_mask ()
void | reset_shapes ()
| Recursively resets the shape on this widget and its descendants. More...
void | path (Glib::ustring& path, Glib::ustring& path_reversed)
| Compute a widget's path of the form "GtkWindow.MyLabel". More...
void | class_path (Glib::ustring&path, Glib::ustring& path_reversed)
Glib::ListHandle< Widget* > | list_mnemonic_labels ()
| Returns a newly allocated list of the widgets, normally labels, for which this widget is a the target of a mnemonic (see for example, Gtk::Label::set_mnemonic_widget()). More...
Glib::ListHandle< const Widget* > | list_mnemonic_labels () const
| Returns a newly allocated list of the widgets, normally labels, for which this widget is a the target of a mnemonic (see for example, Gtk::Label::set_mnemonic_widget()). More...
void | add_mnemonic_label (Widget& label)
| Adds a widget to the list of mnemonic labels for this widget. More...
void | remove_mnemonic_label (Widget& label)
| Removes a widget from the list of mnemonic labels for this widget. More...
void | drag_get_data (const Glib::RefPtr< Gdk::DragContext >& context, Glib::ustring& target, guint32 time)
void | drag_get_data (const Glib::RefPtr< Gdk::DragContext >& context, const Glib::ustring& target, guint32 time)
void | drag_highlight ()
void | drag_unhighlight ()
void | drag_dest_set (DestDefaults flags=DestDefaults(0), Gdk::DragAction actions=Gdk::DragAction(0))
void | drag_dest_set (const ArrayHandle_TargetEntry& targets, DestDefaults flags=DEST_DEFAULT_ALL, Gdk::DragAction actions=Gdk::ACTION_COPY)
void | drag_dest_set_proxy (const Glib::RefPtr< Gdk::Window >& proxy_window, Gdk::DragProtocol protocol, bool use_coordinates)
void | drag_dest_unset ()
Glib::ustring | drag_dest_find_target (const Glib::RefPtr< Gdk::DragContext >& context, const Glib::RefPtr< TargetList >& target_list) const
| Looks for a match between context->targets and the dest_target_list, returning the first matching target, otherwise returning Gdk::NONE. More...
Glib::ustring | drag_dest_find_target (const Glib::RefPtr< Gdk::DragContext >& context) const
Glib::RefPtr< TargetList > | drag_dest_get_target_list ()
| Returns the list of targets this widget can accept from drag-and-drop. More...
Glib::RefPtr< const TargetList > | drag_dest_get_target_list () const
| Returns the list of targets this widget can accept from drag-and-drop. More...
void | drag_dest_set_target_list (const Glib::RefPtr< TargetList >& target_list)
| Sets the target types that this widget can accept from drag-and-drop. More...
void | drag_dest_add_text_targets ()
| Add the text targets supported by Gtk::Selection to the target list of the drag destination. More...
void | drag_dest_add_image_targets ()
| Add the image targets supported by Gtk::Selection to the target list of the drag destination. More...
void | drag_dest_add_uri_targets ()
| Add the URI targets supported by Gtk::Selection to the target list of the drag destination. More...
void | drag_source_set (const ArrayHandle_TargetEntry& targets, Gdk::ModifierType start_button_mask=Gdk::MODIFIER_MASK, Gdk::DragAction actions=Gdk::ACTION_COPY)
void | drag_source_unset ()
void | drag_source_set_icon (const Glib::RefPtr< Gdk::Colormap >& colormap, const Glib::RefPtr< Gdk::Pixmap >& pixmap, const Glib::RefPtr< Gdk::Bitmap >& mask)
| Sets the icon that will be used for drags from a particular widget from a pixmap/mask. More...
void | drag_source_set_icon (const Glib::RefPtr< Gdk::Pixbuf >& pixbuf)
| Sets the icon that will be used for drags from a particular widget from a Gdk::Pixbuf. More...
void | drag_source_set_icon (const StockID& stock_id)
| Sets the icon that will be used for drags from a particular source to a stock icon. More...
void | drag_source_set_icon (const Glib::ustring& icon_name)
| Sets the icon that will be used for drags from a particular source to a themed icon. More...
void | drag_source_add_text_targets ()
| Add the text targets supported by Gtk::Selection to the target list of the drag source. More...
void | drag_source_add_uri_targets ()
| Add the URI targets supported by Gtk::Selection to the target list of the drag source. More...
void | drag_source_add_image_targets ()
| Add the writable image targets supported by Gtk::Selection to the target list of the drag source. More...
Glib::RefPtr< Gdk::DragContext > | drag_begin (const Glib::RefPtr< TargetList >& targets, Gdk::DragAction actions, int button, GdkEvent*event)
| Initiates a drag on the source side. More...
bool | drag_check_threshold (int start_x, int start_y, int current_x, int current_y)
| Checks to see if a mouse drag starting at ( start_x, start_y) and ending at ( current_x, current_y) has passed the GTK+ drag threshold, and thus should trigger the beginning of a drag-and-drop operation. More...
void | drag_set_as_icon (const Glib::RefPtr< Gdk::DragContext >& context, int hot_x, int hot_y)
void | queue_resize_no_redraw ()
| This function works like queue_resize(), except that the widget is not invalidated. More...
bool | get_no_show_all () const
| Returns the current value of the GtkWidget:no-show-all property, which determines whether calls to show_all() and hide_all() will affect this widget. More...
void | set_no_show_all (bool no_show_all=true)
| Sets the Gtk::Widget::property_no_show_all() property, which determines whether calls to show_all() and hide_all() will affect this widget. More...
void | set_parent (Widget& parent)
| This function is useful only when implementing subclasses of Gtk::Container. More...
void | unparent ()
| This function is only for use in widget implementations. More...
void | map ()
| This function is only for use in widget implementations. More...
void | unmap ()
| This function is only for use in widget implementations. More...
void | draw_insertion_cursor (Glib::RefPtr< Gdk::Drawable > drawable, const Gdk::Rectangle& area, const Gdk::Rectangle& location, bool is_primary, TextDirection direction, bool draw_arrow=true)
void | set_tooltip_window (Window& widget)
| Replaces the default, usually yellow, window used for displaying tooltips with widget. More...
Window* | get_tooltip_window ()
| Returns the Gtk::Window of the current tooltip. More...
void | trigger_tooltip_query ()
| Triggers a tooltip query on the display where the toplevel of widget is located. More...
void | set_tooltip_text (const Glib::ustring& text)
| Sets text as the contents of the tooltip. More...
Glib::ustring | get_tooltip_text () const
| Gets the contents of the tooltip for widget. More...
void | set_tooltip_markup (const Glib::ustring& markup)
| Sets markup as the contents of the tooltip, which is marked up with the Pango text markup language. More...
Glib::ustring | get_tooltip_markup () const
| Gets the contents of the tooltip for widget. More...
void | set_has_tooltip (bool has_tooltip=TRUE)
| Sets the has-tooltip property on widget to has_tooltip. More...
bool | get_has_tooltip () const
| Returns the current value of the has-tooltip property. More...
bool | has_no_window () const
bool | is_realized () const
bool | is_mapped () const
bool | is_toplevel () const
bool | is_drawable () const
bool | is_visible () const
bool | sensitive () const
bool | app_paintable () const
bool | receives_default () const
bool | double_buffered () const
bool | parent_sensitive () const
bool | rc_style () const
bool | is_composite_child () const
| Returns trye if the widget is a composite child of its parent. More...
WidgetFlags | get_flags () const
void | set_flags (WidgetFlags flags)
void | unset_flags (WidgetFlags flags)
Gtk::StateType | get_saved_state () const
int | get_width () const
int | get_height () const
bool | is_composited () const
| Whether widget can rely on having its alpha channel drawn correctly. More...
Glib::RefPtr< Action > | get_action ()
| Returns the Gtk::Action that widget is a proxy for. More...
Glib::RefPtr< const Action > | get_action () const
| Returns the Gtk::Action that widget is a proxy for. More...
Requisition | get_requisition () const
| Retrieves the widget's requisition. More...
Glib::SignalProxy< void > | signal_show ()
Glib::SignalProxy< void > | signal_hide ()
Glib::SignalProxy< void > | signal_map ()
| Emitted on mapping of a widget to the screen. More...
Glib::SignalProxy< void > | signal_unmap ()
Glib::SignalProxy< void > | signal_realize ()
| Emitted on realization of a widget. More...
Glib::SignalProxy< void > | signal_unrealize ()
Glib::SignalProxy< void, Requisition*> | signal_size_request ()
Glib::SignalProxy< void, Allocation&> | signal_size_allocate ()
Glib::SignalProxy< void, Gtk::StateType > | signal_state_changed ()
Glib::SignalProxy< void, Widget*> | signal_parent_changed ()
| Informs objects that their parent changed. More...
Glib::SignalProxy< void, Widget*> | signal_hierarchy_changed ()
Glib::SignalProxy< void, const Glib::RefPtr< Gtk::Style >&> | signal_style_changed ()
| The style-set signal is emitted when a new style has been set on a widget. More...
Glib::SignalProxy< void, TextDirection > | signal_direction_changed ()
Glib::SignalProxy< void, bool > | signal_grab_notify ()
Glib::SignalProxy< void, GParamSpec*> | signal_child_notify ()
| The ::child-notify signal is emitted for each child property that has changed on an object. More...
Glib::SignalProxy< bool, bool > | signal_mnemonic_activate ()
Glib::SignalProxy< void > | signal_grab_focus ()
Glib::SignalProxy< bool, DirectionType > | signal_focus ()
Glib::SignalProxy< bool, GdkEvent*> | signal_event ()
Glib::SignalProxy< void, GdkEvent*> | signal_event_after ()
Glib::SignalProxy< bool, GdkEventButton*> | signal_button_press_event ()
| Event triggered by user pressing button. More...
Glib::SignalProxy< bool, GdkEventButton*> | signal_button_release_event ()
| Event triggered by user releasing button. More...
Glib::SignalProxy< bool, GdkEventScroll*> | signal_scroll_event ()
Glib::SignalProxy< bool, GdkEventMotion*> | signal_motion_notify_event ()
| Event triggered by user moving pointer. More...
Glib::SignalProxy< bool, GdkEventAny*> | signal_delete_event ()
| The delete_event signal is emitted if a user requests that a toplevel window is closed. More...
Glib::SignalProxy< bool, GdkEventExpose*> | signal_expose_event ()
| Event triggered by window requiring a refresh. More...
Glib::SignalProxy< bool, GdkEventKey*> | signal_key_press_event ()
| Event triggered by a key press will widget has focus. More...
Glib::SignalProxy< bool, GdkEventKey*> | signal_key_release_event ()
| Event triggered by a key release will widget has focus. More...
Glib::SignalProxy< bool, GdkEventCrossing*> | signal_enter_notify_event ()
| Event triggered by pointer entering widget area. More...
Glib::SignalProxy< bool, GdkEventCrossing*> | signal_leave_notify_event ()
| Event triggered by pointer leaving widget area. More...
Glib::SignalProxy< bool, GdkEventConfigure*> | signal_configure_event ()
| Event triggered by a window resizing. More...
Glib::SignalProxy< bool, GdkEventFocus*> | signal_focus_in_event ()
Glib::SignalProxy< bool, GdkEventFocus*> | signal_focus_out_event ()
Glib::SignalProxy< bool, GdkEventAny*> | signal_map_event ()
Glib::SignalProxy< bool, GdkEventAny*> | signal_unmap_event ()
Glib::SignalProxy< bool, GdkEventProperty*> | signal_property_notify_event ()
Glib::SignalProxy< bool, GdkEventSelection*> | signal_selection_clear_event ()
Glib::SignalProxy< bool, GdkEventSelection*> | signal_selection_request_event ()
Glib::SignalProxy< bool, GdkEventSelection*> | signal_selection_notify_event ()
Glib::SignalProxy< bool, GdkEventProximity*> | signal_proximity_in_event ()
Glib::SignalProxy< bool, GdkEventProximity*> | signal_proximity_out_event ()
Glib::SignalProxy< bool, GdkEventVisibility*> | signal_visibility_notify_event ()
Glib::SignalProxy< bool, GdkEventClient*> | signal_client_event ()
Glib::SignalProxy< bool, GdkEventAny*> | signal_no_expose_event ()
Glib::SignalProxy< bool, GdkEventWindowState*> | signal_window_state_event ()
Glib::SignalProxy< void, SelectionData&, guint, guint > | signal_selection_get ()
Glib::SignalProxy< void, const SelectionData&, guint > | signal_selection_received ()
Glib::SignalProxy< void, const Glib::RefPtr< Gdk::DragContext >&> | signal_drag_begin ()
| The drag_begin signal is emitted on the drag source when a drag is started. More...
Glib::SignalProxy< void, const Glib::RefPtr< Gdk::DragContext >&> | signal_drag_end ()
| The drag_end signal is emitted on the drag source when a drag is finished. More...
Glib::SignalProxy< void, const Glib::RefPtr< Gdk::DragContext >&, SelectionData&, guint, guint > | signal_drag_data_get ()
| The drag_data_get signal is emitted on the drag source when the drop site requests the data which is dragged. More...
Glib::SignalProxy< void, const Glib::RefPtr< Gdk::DragContext >&> | signal_drag_data_delete ()
| The drag_data_delete signal is emitted on the drag source when a drag with the action Gdk::ACTION_MOVE is successfully completed. More...
Glib::SignalProxy< bool, const Glib::RefPtr< Gdk::DragContext >&, DragResult > | signal_drag_failed ()
Glib::SignalProxy< void, const Glib::RefPtr< Gdk::DragContext >&, guint > | signal_drag_leave ()
| The drag_leave signal is emitted on the drop site when the cursor leaves the widget. More...
Glib::SignalProxy< bool, const Glib::RefPtr< Gdk::DragContext >&, int, int, guint > | signal_drag_motion ()
| The drag_motion signal is emitted on the drop site when the user moves the cursor over the widget during a drag. More...
Glib::SignalProxy< bool, const Glib::RefPtr< Gdk::DragContext >&, int, int, guint > | signal_drag_drop ()
| The drag_drop signal is emitted on the drop site when the user drops the data onto the widget. More...
Glib::SignalProxy< void, const Glib::RefPtr< Gdk::DragContext >&, int, int, const SelectionData&, guint, guint > | signal_drag_data_received ()
| The drag_data_received signal is emitted on the drop site when the dragged data has been received. More...
Glib::SignalProxy< Glib::RefPtr< Atk::Object > > | signal_get_accessible ()
Glib::SignalProxy< void, const Glib::RefPtr< Gdk::Screen >&> | signal_screen_changed ()
Glib::SignalProxy< void > | signal_composited_changed ()
Glib::SignalProxy< bool > | signal_popup_menu ()
Glib::SignalProxy< bool, int, int, bool, const Glib::RefPtr< Tooltip >&> | signal_query_tooltip ()
Glib::SignalProxy< bool, GdkEventGrabBroken*> | signal_grab_broken_event ()
Glib::SignalProxy< bool, GdkEventExpose*> | signal_damage_event ()
Glib::PropertyProxy< Glib::ustring > | property_name ()
| The name of the widget. More...
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_name () const
| The name of the widget. More...
Glib::PropertyProxy< Container*> | property_parent ()
| The parent widget of this widget. More...
Glib::PropertyProxy_ReadOnly< Container*> | property_parent () const
| The parent widget of this widget. More...
Glib::PropertyProxy< int > | property_width_request ()
| Override for width request of the widget, or -1 if natural request should be used. More...
Glib::PropertyProxy_ReadOnly< int > | property_width_request () const
| Override for width request of the widget, or -1 if natural request should be used. More...
Glib::PropertyProxy< int > | property_height_request ()
| Override for height request of the widget, or -1 if natural request should be used. More...
Glib::PropertyProxy_ReadOnly< int > | property_height_request () const
| Override for height request of the widget, or -1 if natural request should be used. More...
Glib::PropertyProxy< bool > | property_visible ()
| Whether the widget is visible. More...
Glib::PropertyProxy_ReadOnly< bool > | property_visible () const
| Whether the widget is visible. More...
Glib::PropertyProxy< bool > | property_sensitive ()
| Whether the widget responds to input. More...
Glib::PropertyProxy_ReadOnly< bool > | property_sensitive () const
| Whether the widget responds to input. More...
Glib::PropertyProxy< bool > | property_app_paintable ()
| Whether the application will paint directly on the widget. More...
Glib::PropertyProxy_ReadOnly< bool > | property_app_paintable () const
| Whether the application will paint directly on the widget. More...
Glib::PropertyProxy< bool > | property_can_focus ()
| Whether the widget can accept the input focus. More...
Glib::PropertyProxy_ReadOnly< bool > | property_can_focus () const
| Whether the widget can accept the input focus. More...
Glib::PropertyProxy< bool > | property_has_focus ()
| Whether the widget has the input focus. More...
Glib::PropertyProxy_ReadOnly< bool > | property_has_focus () const
| Whether the widget has the input focus. More...
Glib::PropertyProxy< bool > | property_is_focus ()
| Whether the widget is the focus widget within the toplevel. More...
Glib::PropertyProxy_ReadOnly< bool > | property_is_focus () const
| Whether the widget is the focus widget within the toplevel. More...
Glib::PropertyProxy< bool > | property_can_default ()
| Whether the widget can be the default widget. More...
Glib::PropertyProxy_ReadOnly< bool > | property_can_default () const
| Whether the widget can be the default widget. More...
Glib::PropertyProxy< bool > | property_has_default ()
| Whether the widget is the default widget. More...
Glib::PropertyProxy_ReadOnly< bool > | property_has_default () const
| Whether the widget is the default widget. More...
Glib::PropertyProxy< bool > | property_receives_default ()
| If TRUE, the widget will receive the default action when it is focused. More...
Glib::PropertyProxy_ReadOnly< bool > | property_receives_default () const
| If TRUE, the widget will receive the default action when it is focused. More...
Glib::PropertyProxy_ReadOnly< bool > | property_composite_child () const
| Whether the widget is part of a composite widget. More...
Glib::PropertyProxy< Glib::RefPtr< Style > > | property_style ()
| The style of the widget, which contains information about how it will look (colors etc). More...
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Style > > | property_style () const
| The style of the widget, which contains information about how it will look (colors etc). More...
Glib::PropertyProxy< Gdk::EventMask > | property_events ()
| The event mask that decides what kind of GdkEvents this widget gets. More...
Glib::PropertyProxy_ReadOnly< Gdk::EventMask > | property_events () const
| The event mask that decides what kind of GdkEvents this widget gets. More...
Glib::PropertyProxy< Gdk::ExtensionMode > | property_extension_events ()
| The mask that decides what kind of extension events this widget gets. More...
Glib::PropertyProxy_ReadOnly< Gdk::ExtensionMode > | property_extension_events () const
| The mask that decides what kind of extension events this widget gets. More...
Glib::PropertyProxy< bool > | property_has_tooltip ()
| Whether this widget has a tooltip. More...
Glib::PropertyProxy_ReadOnly< bool > | property_has_tooltip () const
| Whether this widget has a tooltip. More...
Glib::PropertyProxy< Glib::ustring > | property_tooltip_markup ()
| The contents of the tooltip for this widget. More...
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_tooltip_markup () const
| The contents of the tooltip for this widget. More...
Glib::PropertyProxy< Glib::ustring > | property_tooltip_text ()
| The contents of the tooltip for this widget. More...
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_tooltip_text () const
| The contents of the tooltip for this widget. More...
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Gdk::Window > > | property_window () const
| The widget's window if it is realized. More...
Glib::PropertyProxy< bool > | property_no_show_all ()
| Whether gtk_widget_show_all() should not affect this widget. More...
Glib::PropertyProxy_ReadOnly< bool > | property_no_show_all () const
| Whether gtk_widget_show_all() should not affect this widget. More...
Glib::PropertyProxy< bool > | property_double_buffered ()
| Whether or not the widget is double buffered. More...
Glib::PropertyProxy_ReadOnly< bool > | property_double_buffered () const
| Whether or not the widget is double buffered. More...
Public Member Functions inherited from Gtk::Object
virtual | ~Object ()
GtkObject* | gobj ()
| Provides access to the underlying C GtkObject. More...
const GtkObject* | gobj () const
| Provides access to the underlying C GtkObject. More...
Glib::PropertyProxy< void*> | property_user_data ()
| Anonymous User Data Pointer. More...
Glib::PropertyProxy_ReadOnly< void*> | property_user_data () const
| Anonymous User Data Pointer. More...
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
void | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void > &slot)
void | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void > &&slot)
sigc::connection | connect_property_changed_with_return (const Glib::ustring &property_name, const sigc::slot< void > &slot)
sigc::connection | connect_property_changed_with_return (const Glib::ustring &property_name, sigc::slot< void > &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src)
| ~trackable ()
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src)
void | remove_destroy_notify_callback (void *data) const
Public Member Functions inherited from Atk::Implementor
| Implementor (Implementor &&src) noexcept
Implementor & | operator= (Implementor &&src) noexcept
| ~Implementor () noexcept override
AtkImplementor * | gobj ()
const AtkImplementor * | gobj () const
Glib::RefPtr< Atk::Implementor > | wrap (AtkImplementor *object, bool take_copy=false)
Public Member Functions inherited from Glib::Interface
| Interface ()
| Interface (Interface &&src) noexcept
Interface & | operator= (Interface &&src) noexcept
| Interface (const Glib::Interface_Class &interface_class)
| Interface (GObject *castitem)
| ~Interface () noexcept override
| Interface (const Interface &)=delete
Interface & | operator= (const Interface &)=delete
GObject * | gobj ()
const GObject * | gobj () const

## Static Public Member Functions
static void | set_default_icon_list (const Glib::ListHandle< Glib::RefPtr< Gdk::Pixbuf > >& list)
| Sets an icon list to be used as fallback for windows that haven't had set_icon_list() called on them to set up a window-specific icon list. More...
static Glib::ListHandle< Glib::RefPtr< Gdk::Pixbuf > > | get_default_icon_list ()
| Gets the value set by Gtk::Window::set_default_icon_list(). More...
static void | set_default_icon (const Glib::RefPtr< Gdk::Pixbuf >& icon)
| Sets an icon to be used as fallback for windows that haven't had set_icon() called on them from a pixbuf. More...
static void | set_default_icon_name (const Glib::ustring& name)
| Sets an icon to be used as fallback for windows that haven't had set_icon_list() called on them from a named themed icon, see set_icon_name(). More...
static bool | set_default_icon_from_file (const std::string& filename)
| Sets an icon to be used as fallback for windows that haven't had set_icon_list() called on them from a file on disk. More...
static void | set_auto_startup_notification (bool setting=true)
| By default, after showing the first Gtk::Window, GTK+ calls gdk_notify_startup_complete(). More...
static Glib::ListHandle< Window* > | list_toplevels ()
| Returns a list of all existing toplevel windows. More...
Static Public Member Functions inherited from Gtk::Widget
static Widget* | get_current_modal_grab ()
| Retrieve the widget which is currently grabbing all events. More...
static void | push_colormap (const Glib::RefPtr< const Gdk::Colormap >& cmap)
| Pushes cmap onto a global stack of colormaps; the topmost colormap on the stack will be used to create all widgets. More...
static void | pop_colormap ()
| Removes a colormap pushed with push_colormap(). More...
static void | push_composite_child ()
| Makes all newly-created widgets as composite children until the corresponding pop_composite_child() call. More...
static void | pop_composite_child ()
| Cancels the effect of a previous call to push_composite_child(). More...
static void | set_default_colormap (const Glib::RefPtr< const Gdk::Colormap >& colormap)
| Sets the default colormap to use when creating widgets. More...
static Glib::RefPtr< Style > | get_default_style ()
| Returns the default style used by all widgets initially. More...
static Glib::RefPtr< Gdk::Colormap > | get_default_colormap ()
| Obtains the default colormap used to create widgets. More...
static Glib::RefPtr< Gdk::Visual > | get_default_visual ()
| Obtains the visual of the default colormap. More...
static void | set_default_direction (TextDirection dir)
| Sets the default reading direction for widgets where the direction has not been explicitly set by set_direction(). More...
static TextDirection | get_default_direction ()
| Obtains the current default reading direction. More...
static Widget* | drag_get_source_widget (const Glib::RefPtr< Gdk::DragContext >& context)
Static Public Member Functions inherited from Atk::Implementor
static void | add_interface (GType gtype_implementer)
static GType | get_type ()

## Protected Member Functions
virtual void | on_set_focus (Widget* focus)
| This is a default handler for the signal signal_set_focus(). More...
virtual bool | on_frame_event (GdkEvent*event)
| This is a default handler for the signal signal_frame_event(). More...
void | destroy_ ()
Protected Member Functions inherited from Gtk::Bin
| Bin ()
| This constructor is protected because only derived classes should be instantiated. More...
Protected Member Functions inherited from Gtk::Container
virtual void | on_add (Widget* widget)
| This is a default handler for the signal signal_add(). More...
virtual void | on_remove (Widget* widget)
| This is a default handler for the signal signal_remove(). More...
virtual void | on_check_resize ()
| This is a default handler for the signal signal_check_resize(). More...
virtual void | on_set_focus_child (Widget* widget)
| This is a default handler for the signal signal_set_focus_child(). More...
| Container ()
virtual GType | child_type_vfunc () const
virtual void | forall_vfunc (gboolean include_internals, GtkCallback callback, gpointer callback_data)
virtual char* | composite_name_vfunc (GtkWidget* child)
virtual void | set_child_property_vfunc (GtkWidget* child, guint property_id, const GValue* value, GParamSpec* pspec)
virtual void | get_child_property_vfunc (GtkWidget* child, guint property_id, GValue* value, GParamSpec* pspec) const
Glib::PropertyProxy< guint > | property_border_width ()
| The width of the empty border outside the containers children. More...
Glib::PropertyProxy_ReadOnly< guint > | property_border_width () const
| The width of the empty border outside the containers children. More...
Glib::PropertyProxy< ResizeMode > | property_resize_mode ()
| Specify how resize events are handled. More...
Glib::PropertyProxy_ReadOnly< ResizeMode > | property_resize_mode () const
| Specify how resize events are handled. More...
Glib::PropertyProxy_WriteOnly< Widget*> | property_child ()
| Can be used to add a new child to the container. More...
Protected Member Functions inherited from Gtk::Widget
virtual void | on_show ()
| This is a default handler for the signal signal_show(). More...
virtual void | on_hide ()
| This is a default handler for the signal signal_hide(). More...
virtual void | on_map ()
| This is a default handler for the signal signal_map(). More...
virtual void | on_unmap ()
| This is a default handler for the signal signal_unmap(). More...
virtual void | on_realize ()
| This is a default handler for the signal signal_realize(). More...
virtual void | on_unrealize ()
| This is a default handler for the signal signal_unrealize(). More...
virtual void | on_size_request (Requisition* requisition)
| This is a default handler for the signal signal_size_request(). More...
virtual void | on_size_allocate (Allocation& allocation)
| This is a default handler for the signal signal_size_allocate(). More...
virtual void | on_state_changed (Gtk::StateType previous_state)
| This is a default handler for the signal signal_state_changed(). More...
virtual void | on_parent_changed (Widget* previous_parent)
| This is a default handler for the signal signal_parent_changed(). More...
virtual void | on_hierarchy_changed (Widget* previous_toplevel)
| This is a default handler for the signal signal_hierarchy_changed(). More...
virtual void | on_style_changed (const Glib::RefPtr< Gtk::Style >& previous_style)
| This is a default handler for the signal signal_style_changed(). More...
virtual void | on_direction_changed (TextDirection direction)
| This is a default handler for the signal signal_direction_changed(). More...
virtual void | on_grab_notify (bool was_grabbed)
| This is a default handler for the signal signal_grab_notify(). More...
virtual void | on_child_notify (GParamSpec* pspec)
| This is a default handler for the signal signal_child_notify(). More...
virtual bool | on_mnemonic_activate (bool group_cycling)
| This is a default handler for the signal signal_mnemonic_activate(). More...
virtual void | on_grab_focus ()
| This is a default handler for the signal signal_grab_focus(). More...
virtual bool | on_focus (DirectionType direction)
| This is a default handler for the signal signal_focus(). More...
virtual bool | on_event (GdkEvent*event)
| This is a default handler for the signal signal_event(). More...
virtual bool | on_button_press_event (GdkEventButton*event)
| This is a default handler for the signal signal_button_press_event(). More...
virtual bool | on_button_release_event (GdkEventButton*event)
| This is a default handler for the signal signal_button_release_event(). More...
virtual bool | on_scroll_event (GdkEventScroll*event)
| This is a default handler for the signal signal_scroll_event(). More...
virtual bool | on_motion_notify_event (GdkEventMotion*event)
| This is a default handler for the signal signal_motion_notify_event(). More...
virtual bool | on_delete_event (GdkEventAny*event)
| This is a default handler for the signal signal_delete_event(). More...
virtual bool | on_expose_event (GdkEventExpose*event)
| This is a default handler for the signal signal_expose_event(). More...
virtual bool | on_key_press_event (GdkEventKey*event)
| This is a default handler for the signal signal_key_press_event(). More...
virtual bool | on_key_release_event (GdkEventKey*event)
| This is a default handler for the signal signal_key_release_event(). More...
virtual bool | on_enter_notify_event (GdkEventCrossing*event)
| This is a default handler for the signal signal_enter_notify_event(). More...
virtual bool | on_leave_notify_event (GdkEventCrossing*event)
| This is a default handler for the signal signal_leave_notify_event(). More...
virtual bool | on_configure_event (GdkEventConfigure*event)
| This is a default handler for the signal signal_configure_event(). More...
virtual bool | on_focus_in_event (GdkEventFocus*event)
| This is a default handler for the signal signal_focus_in_event(). More...
virtual bool | on_focus_out_event (GdkEventFocus*event)
| This is a default handler for the signal signal_focus_out_event(). More...
virtual bool | on_map_event (GdkEventAny*event)
| This is a default handler for the signal signal_map_event(). More...
virtual bool | on_unmap_event (GdkEventAny*event)
| This is a default handler for the signal signal_unmap_event(). More...
virtual bool | on_property_notify_event (GdkEventProperty*event)
| This is a default handler for the signal signal_property_notify_event(). More...
virtual bool | on_selection_clear_event (GdkEventSelection*event)
| This is a default handler for the signal signal_selection_clear_event(). More...
virtual bool | on_selection_request_event (GdkEventSelection*event)
| This is a default handler for the signal signal_selection_request_event(). More...
virtual bool | on_selection_notify_event (GdkEventSelection*event)
| This is a default handler for the signal signal_selection_notify_event(). More...
virtual bool | on_proximity_in_event (GdkEventProximity*event)
| This is a default handler for the signal signal_proximity_in_event(). More...
virtual bool | on_proximity_out_event (GdkEventProximity*event)
| This is a default handler for the signal signal_proximity_out_event(). More...
virtual bool | on_visibility_notify_event (GdkEventVisibility*event)
| This is a default handler for the signal signal_visibility_notify_event(). More...
virtual bool | on_client_event (GdkEventClient*event)
| This is a default handler for the signal signal_client_event(). More...
virtual bool | on_no_expose_event (GdkEventAny*event)
| This is a default handler for the signal signal_no_expose_event(). More...
virtual bool | on_window_state_event (GdkEventWindowState*event)
| This is a default handler for the signal signal_window_state_event(). More...
virtual void | on_selection_get (SelectionData& selection_data, guint info, guint time)
| This is a default handler for the signal signal_selection_get(). More...
virtual void | on_selection_received (const SelectionData& selection_data, guint time)
| This is a default handler for the signal signal_selection_received(). More...
virtual void | on_drag_begin (const Glib::RefPtr< Gdk::DragContext >& context)
| This is a default handler for the signal signal_drag_begin(). More...
virtual void | on_drag_end (const Glib::RefPtr< Gdk::DragContext >& context)
| This is a default handler for the signal signal_drag_end(). More...
virtual void | on_drag_data_get (const Glib::RefPtr< Gdk::DragContext >& context, SelectionData& selection_data, guint info, guint time)
| This is a default handler for the signal signal_drag_data_get(). More...
virtual void | on_drag_data_delete (const Glib::RefPtr< Gdk::DragContext >& context)
| This is a default handler for the signal signal_drag_data_delete(). More...
virtual void | on_drag_leave (const Glib::RefPtr< Gdk::DragContext >& context, guint time)
| This is a default handler for the signal signal_drag_leave(). More...
virtual bool | on_drag_motion (const Glib::RefPtr< Gdk::DragContext >& context, int x, int y, guint time)
| This is a default handler for the signal signal_drag_motion(). More...
virtual bool | on_drag_drop (const Glib::RefPtr< Gdk::DragContext >& context, int x, int y, guint time)
| This is a default handler for the signal signal_drag_drop(). More...
virtual void | on_drag_data_received (const Glib::RefPtr< Gdk::DragContext >& context, int x, int y, const SelectionData& selection_data, guint info, guint time)
| This is a default handler for the signal signal_drag_data_received(). More...
virtual Glib::RefPtr< Atk::Object > | on_get_accessible ()
| This is a default handler for the signal signal_get_accessible(). More...
virtual void | on_screen_changed (const Glib::RefPtr< Gdk::Screen >& previous_screen)
| This is a default handler for the signal signal_screen_changed(). More...
virtual void | dispatch_child_properties_changed_vfunc (guint p1, GParamSpec** p2)
virtual void | show_all_vfunc ()
virtual void | hide_all_vfunc ()
virtual Glib::RefPtr< Atk::Object > | get_accessible_vfunc ()
| Widget ()
void | realize ()
| Creates the GDK (windowing system) resources associated with a widget. More...
void | unrealize ()
| This function is only useful in widget implementations. More...
void | set_mapped (bool mapped=true)
| Marks the widget as being realized. More...
void | set_realized (bool realized=true)
| Marks the widget as being realized. More...
void | style_attach ()
| This function attaches the widget's Gtk::Style to the widget's Gdk::Window. More...
void | get_child_requisition (Requisition& requisition) const
| This function is only for use in widget implementations. More...
void | get_style_property_value (const Glib::ustring& the_property_name, Glib::ValueBase& value) const
| Gets the value of a style property of widget. More...
void | realize_if_needed ()
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)
Protected Member Functions inherited from Atk::Implementor
| Implementor ()
virtual Glib::RefPtr< Object > | ref_accessibile_vfunc ()

## Related Functions
(Note that these are not member functions.)
Gtk::Window* | wrap (GtkWindow* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gtk::Bin
Gtk::Bin* | wrap (GtkBin* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gtk::Container
Gtk::Container* | wrap (GtkContainer* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gtk::Widget
Gtk::Widget* | wrap (GtkWidget* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gtk::Object
Gtk::Object* | wrap (GtkObject* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Additional Inherited Members
Public Types inherited from Gtk::Container
typedef sigc::slot< void, Widget& > | ForeachSlot
| For instance, void on_foreach(Gtk::Widget* widget);. More...
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify

## Detailed Description

Toplevel Window This represents all widgets which are physical windows controlled by the window manager.

The window will be hidden when the window manager's close button is clicked. Override on_delete_event() to stop this.

Gtk::manage() has no effect on Windows because they have no parent Containers.

## Constructor & Destructor Documentation

## ◆ ~Window()

virtual Gtk::Window::~Window | ( |  | ) |
| virtual

## ◆ Window()

Gtk::Window::Window | ( | WindowType | type = `WINDOW_TOPLEVEL` | ) |
| explicit

## Member Function Documentation

## ◆ activate_default()

bool Gtk::Window::activate_default | ( |  | ) |

Activates the default widget for the window, unless the current focused widget has been configured to receive the default action (see Gtk::Widget::set_receives_default()), in which case the focused widget is activated.

Returns
  `true` if a widget got activated.

## ◆ activate_focus()

bool Gtk::Window::activate_focus | ( |  | ) |

Activates the current focused widget within the window.

Returns
  `true` if a widget got activated.

## ◆ add_accel_group()

void Gtk::Window::add_accel_group | ( | const Glib::RefPtr< AccelGroup >& | accel_group | ) |

Associate accel_group with window, such that calling gtk_accel_groups_activate() on window will activate accelerators in accel_group.

Parameters

  accel_group | A Gtk::AccelGroup.

## ◆ add_mnemonic()

void Gtk::Window::add_mnemonic | ( | guint | keyval,
|  | Widget& | target
| ) |  |

Adds a mnemonic to this window.

Parameters

  keyval | The mnemonic.
  target | The widget that gets activated by the mnemonic.

## ◆ begin_move_drag()

void Gtk::Window::begin_move_drag | ( | int | button,
|  | int | root_x,
|  | int | root_y,
|  | guint32 | timestamp
| ) |  |

Starts moving a window.

This function is used if an application has window movement grips. When GDK can support it, the window movement will be done using the standard mechanism for the window manager or windowing system. Otherwise, GDK will try to emulate window movement, potentially not all that well, depending on the windowing system.

Parameters

  button | Mouse button that initiated the drag.
  root_x | X position where the user clicked to initiate the drag, in root window coordinates.
  root_y | Y position where the user clicked to initiate the drag.
  timestamp | Timestamp from the click event that initiated the drag.

## ◆ begin_resize_drag()

void Gtk::Window::begin_resize_drag | ( | Gdk::WindowEdge | edge,
|  | int | button,
|  | int | root_x,
|  | int | root_y,
|  | guint32 | timestamp
| ) |  |

Starts resizing a window.

This function is used if an application has window resizing controls. When GDK can support it, the resize will be done using the standard mechanism for the window manager or windowing system. Otherwise, GDK will try to emulate window resizing, potentially not all that well, depending on the windowing system.

Parameters

  button | Mouse button that initiated the drag.
  edge | Position of the resize control.
  root_x | X position where the user clicked to initiate the drag, in root window coordinates.
  root_y | Y position where the user clicked to initiate the drag.
  timestamp | Timestamp from the click event that initiated the drag.

## ◆ deiconify()

void Gtk::Window::deiconify | ( |  | ) |

Asks to deiconify (i.e. unminimize) the specified window.

Note that you shouldn't assume the window is definitely deiconified afterward, because other entities (e.g. the user or window manager) could iconify it again before your code which assumes deiconification gets to run.

You can track iconification via the "window-state-event" signal on Gtk::Widget.

## ◆ destroy_()

void Gtk::Window::destroy_ | ( |  | ) |
| protected

## ◆ fullscreen()

void Gtk::Window::fullscreen | ( |  | ) |

Asks to place window in the fullscreen state.

Note that you shouldn't assume the window is definitely full screen afterward, because other entities (e.g. the user or window manager) could unfullscreen it again, and not all window managers honor requests to fullscreen windows. But normally the window will end up fullscreen. Just don't write code that crashes if not.

You can track the fullscreen state via the "window-state-event" signal on Gtk::Widget.

Since gtkmm 2.2:

## ◆ get_accel_group()

Glib::RefPtr<AccelGroup> Gtk::Window::get_accel_group | ( |  | ) |

Returns a default accel group for this window This is a gtkmm-specific function.

This accel group can not be removed.

## ◆ get_accept_focus()

bool Gtk::Window::get_accept_focus | ( |  | ) | const

Gets the value set by set_accept_focus().

Since gtkmm 2.4:

Returns
  `true` if window should receive the input focus.

## ◆ get_decorated()

bool Gtk::Window::get_decorated | ( |  | ) | const

Returns whether the window has been set to have decorations such as a title bar via set_decorated().

Returns
  `true` if the window has been set to have decorations.

## ◆ get_default_icon_list()

static Glib::ListHandle< Glib::RefPtr<Gdk::Pixbuf> > Gtk::Window::get_default_icon_list | ( |  | ) |
| static

Gets the value set by Gtk::Window::set_default_icon_list().

Returns
  Copy of default icon list.

## ◆ get_default_size()

void Gtk::Window::get_default_size | ( | int & | width,
|  | int & | height
| ) |  | const

Gets the default size of the window.

A value of -1 for the width or height indicates that a default size has not been explicitly set for that dimension, so the "natural" size of the window will be used.

Parameters

  width | Location to store the default width.
  height | Location to store the default height.

## ◆ get_deletable()

bool Gtk::Window::get_deletable | ( |  | ) | const

Returns whether the window has been set to have a close button via set_deletable().

Since gtkmm 2.10:

Returns
  `true` if the window has been set to have a close button.

## ◆ get_destroy_with_parent()

bool Gtk::Window::get_destroy_with_parent | ( |  | ) | const

Returns whether the window will be destroyed with its transient parent.

See set_destroy_with_parent().

Returns
  `true` if the window will be destroyed with its transient parent.

## ◆ get_focus() [1/2]

Widget* Gtk::Window::get_focus | ( |  | ) |

Retrieves the current focused widget within the window.

Note that this is the widget that would have the focus if the toplevel window focused; if the toplevel window is not focused then `gtk_widget_has_focus (widget)` will not be `true` for the widget.

Returns
  The currently focused widget, or `nullptr` if there is none.

## ◆ get_focus() [2/2]

const Widget* Gtk::Window::get_focus | ( |  | ) | const

Retrieves the current focused widget within the window.

Note that this is the widget that would have the focus if the toplevel window focused; if the toplevel window is not focused then `gtk_widget_has_focus (widget)` will not be `true` for the widget.

Returns
  The currently focused widget, or `nullptr` if there is none.

## ◆ get_focus_on_map()

bool Gtk::Window::get_focus_on_map | ( |  | ) | const

Gets the value set by set_focus_on_map().

Since gtkmm 2.6:

Returns
  `true` if window should receive the input focus when mapped.

## ◆ get_frame() [1/2]

Glib::RefPtr<Gdk::Window> Gtk::Window::get_frame | ( |  | ) |

Deprecated:
  You should not need to call this method.

## ◆ get_frame() [2/2]

Glib::RefPtr<const Gdk::Window> Gtk::Window::get_frame | ( |  | ) | const

## ◆ get_frame_dimensions()

void Gtk::Window::get_frame_dimensions | ( | int & | left,
|  | int & | top,
|  | int & | right,
|  | int & | bottom
| ) |  | const

(Note: this is a special-purpose function intended for the framebuffer port; see set_has_frame().

It will not return the size of the window border drawn by the window manager, which is the normal case when using a windowing system. See gdk_window_get_frame_extents() to get the standard window border extents.)

Retrieves the dimensions of the frame window for this toplevel. See set_has_frame(), set_frame_dimensions().

Deprecated: 2.24: This function will be removed in GTK+ 3

Parameters

  left | Location to store the width of the frame at the left.
  top | Location to store the height of the frame at the top.
  right | Location to store the width of the frame at the returns.
  bottom | Location to store the height of the frame at the bottom.

## ◆ get_gravity()

Gdk::Gravity Gtk::Window::get_gravity | ( |  | ) | const

Gets the value set by set_gravity().

Returns
  Window gravity.

## ◆ get_group() [1/2]

Glib::RefPtr<WindowGroup> Gtk::Window::get_group | ( |  | ) |

Returns the group for window or the default group, if window is `nullptr` or if window does not have an explicit window group.

Since gtkmm 2.10:

Returns
  The Gtk::WindowGroup for a window or the default group.

## ◆ get_group() [2/2]

Glib::RefPtr<const WindowGroup> Gtk::Window::get_group | ( |  | ) | const

Returns the group for window or the default group, if window is `nullptr` or if window does not have an explicit window group.

Since gtkmm 2.10:

Returns
  The Gtk::WindowGroup for a window or the default group.

## ◆ get_has_frame()

bool Gtk::Window::get_has_frame | ( |  | ) | const

Accessor for whether the window has a frame window exterior to window->window.

Gets the value set by set_has_frame().

Deprecated: 2.24: This function will be removed in GTK+ 3

Returns
  `true` if a frame has been added to the window via set_has_frame().

## ◆ get_icon() [1/2]

Glib::RefPtr<Gdk::Pixbuf> Gtk::Window::get_icon | ( |  | ) |

Gets the value set by set_icon() (or if you've called set_icon_list(), gets the first icon in the icon list).

Returns
  Icon for window.

## ◆ get_icon() [2/2]

Glib::RefPtr<const Gdk::Pixbuf> Gtk::Window::get_icon | ( |  | ) | const

Gets the value set by set_icon() (or if you've called set_icon_list(), gets the first icon in the icon list).

Returns
  Icon for window.

## ◆ get_icon_list() [1/2]

Glib::ListHandle< Glib::RefPtr<Gdk::Pixbuf> > Gtk::Window::get_icon_list | ( |  | ) |

Retrieves the list of icons set by set_icon_list().

The list is copied, but the reference count on each member won't be incremented.

Returns
  Copy of window's icon list.

## ◆ get_icon_list() [2/2]

Glib::ListHandle< Glib::RefPtr<const Gdk::Pixbuf> > Gtk::Window::get_icon_list | ( |  | ) | const

Retrieves the list of icons set by set_icon_list().

The list is copied, but the reference count on each member won't be incremented.

Returns
  Copy of window's icon list.

## ◆ get_icon_name()

Glib::ustring Gtk::Window::get_icon_name | ( |  | ) | const

Returns the name of the themed icon for the window, see set_icon_name().

Since gtkmm 2.6:

Returns
  The icon name or `nullptr` if the window has no themed icon.

## ◆ get_mnemonic_modifier()

Gdk::ModifierType Gtk::Window::get_mnemonic_modifier | ( |  | ) |

Returns the mnemonic modifier for this window.

See set_mnemonic_modifier().

Returns
  The modifier mask used to activate mnemonics on this window.

## ◆ get_mnemonics_visible()

bool Gtk::Window::get_mnemonics_visible | ( |  | ) | const

## ◆ get_modal()

bool Gtk::Window::get_modal | ( |  | ) | const

Returns whether the window is modal.

See set_modal().

Returns
  `true` if the window is set to be modal and establishes a grab when shown.

## ◆ get_opacity()

double Gtk::Window::get_opacity | ( |  | ) | const

Fetches the requested opacity for this window.

See set_opacity().

Since gtkmm 2.12:

Returns
  The requested opacity for this window.

## ◆ get_position()

void Gtk::Window::get_position | ( | int & | root_x,
|  | int & | root_y
| ) |  | const

This function returns the position you need to pass to move() to keep window in its current position.

This means that the meaning of the returned value varies with window gravity. See move() for more details.

If you haven't changed the window gravity, its gravity will be Gdk::GRAVITY_NORTH_WEST. This means that get_position() gets the position of the top-left corner of the window manager frame for the window. move() sets the position of this same top-left corner.

get_position() is not 100% reliable because the X Window System does not specify a way to obtain the geometry of the decorations placed on a window by the window manager. Thus GTK+ is using a "best guess" that works with most window managers.

Moreover, nearly all window managers are historically broken with respect to their handling of window gravity. So moving a window to its current position as returned by get_position() tends to result in moving the window slightly. Window managers are slowly getting better over time.

If a window has gravity Gdk::GRAVITY_STATIC the window manager frame is not relevant, and thus get_position() will always produce accurate results. However you can't use static gravity to do things like place a window in a corner of the screen, because static gravity ignores the window manager decorations.

If you are saving and restoring your application's window positions, you should know that it's impossible for applications to do this without getting it somewhat wrong because applications do not have sufficient knowledge of window manager state. The Correct Mechanism is to support the session management protocol (see the "GnomeClient" object in the GNOME libraries for example) and allow the window manager to save your window sizes and positions.

Parameters

  root_x | Return location for X coordinate of gravity-determined reference point.
  root_y | Return location for Y coordinate of gravity-determined reference point.

## ◆ get_resizable()

bool Gtk::Window::get_resizable | ( |  | ) | const

Gets the value set by set_resizable().

Returns
  `true` if the user can resize the window.

## ◆ get_role()

Glib::ustring Gtk::Window::get_role | ( |  | ) | const

Returns the role of the window.

See set_role() for further explanation.

Returns
  The role of the window if set, or `nullptr`. The returned is owned by the widget and must not be modified or freed.

## ◆ get_screen() [1/2]

Glib::RefPtr<Gdk::Screen> Gtk::Window::get_screen | ( |  | ) |

Returns the Gdk::Screen associated with window.

Since gtkmm 2.2:

Returns
  A Gdk::Screen.

## ◆ get_screen() [2/2]

Glib::RefPtr<const Gdk::Screen> Gtk::Window::get_screen | ( |  | ) | const

Returns the Gdk::Screen associated with window.

Since gtkmm 2.2:

Returns
  A Gdk::Screen.

## ◆ get_size()

void Gtk::Window::get_size | ( | int & | width,
|  | int & | height
| ) |  | const

Obtains the current size of window.

If window is not onscreen, it returns the size GTK+ will suggest to the window manager for the initial window size (but this is not reliably the same as the size the window manager will actually select). The size obtained by get_size() is the last size received in a Gdk::EventConfigure, that is, GTK+ uses its locally-stored size, rather than querying the X server for the size. As a result, if you call resize() then immediately call get_size(), the size won't have taken effect yet. After the window manager processes the resize request, GTK+ receives notification that the size has changed via a configure event, and the size of the window gets updated.

Note
  Nearly any use of this function creates a race condition, because the size of the window may change between the time that you get the size and the time that you perform some action assuming that size is the current size. To avoid race conditions, connect to "configure-event" on the window and adjust your size-dependent state to match the size delivered in the Gdk::EventConfigure.
  The returned size does not include the size of the window manager decorations (aka the window frame or border). Those are not drawn by GTK+ and GTK+ has no reliable method of determining their size.
  If you are getting a window size in order to position the window onscreen, there may be a better way. The preferred way is to simply set the window's semantic type with set_type_hint(), which allows the window manager to e.g. center dialogs. Also, if you set the transient parent of dialogs with set_transient_for() window managers will often center the dialog over its parent window. It's much preferred to let the window manager handle these things rather than doing it yourself, because all apps will behave consistently and according to user prefs if the window manager handles it. Also, the window manager can take the size of the window decorations/border into account, while your application cannot.

In any case, if you insist on application-specified window positioning, there's still a better way than doing it yourself - set_position() will frequently handle the details for you.

Parameters

  width | Return location for width.
  height | Return location for height.

## ◆ get_skip_pager_hint()

bool Gtk::Window::get_skip_pager_hint | ( |  | ) | const

Gets the value set by set_skip_pager_hint().

Since gtkmm 2.2:

Returns
  `true` if window shouldn't be in pager.

## ◆ get_skip_taskbar_hint()

bool Gtk::Window::get_skip_taskbar_hint | ( |  | ) | const

Gets the value set by set_skip_taskbar_hint()

Since gtkmm 2.2:

Returns
  `true` if window shouldn't be in taskbar.

## ◆ get_title()

Glib::ustring Gtk::Window::get_title | ( |  | ) | const

Retrieves the title of the window.

See set_title().

Returns
  The title of the window, or `nullptr` if none has been set explicitely. The returned string is owned by the widget and must not be modified or freed.

## ◆ get_transient_for() [1/2]

Window* Gtk::Window::get_transient_for | ( |  | ) |

Fetches the transient parent for this window.

See set_transient_for().

Returns
  The transient parent for this window, or `nullptr` if no transient parent has been set.

## ◆ get_transient_for() [2/2]

const Window* Gtk::Window::get_transient_for | ( |  | ) | const

Fetches the transient parent for this window.

See set_transient_for().

Returns
  The transient parent for this window, or `nullptr` if no transient parent has been set.

## ◆ get_type_hint()

Gdk::WindowTypeHint Gtk::Window::get_type_hint | ( |  | ) | const

Gets the type hint for this window.

See set_type_hint().

Returns
  The type hint for window.

## ◆ get_urgency_hint()

bool Gtk::Window::get_urgency_hint | ( |  | ) | const

Gets the value set by set_urgency_hint()

Since gtkmm 2.8:

Returns
  `true` if window is urgent.

## ◆ get_window_type()

WindowType Gtk::Window::get_window_type | ( |  | ) | const

Gets the type of the window.

See Gtk::WindowType.

Since gtkmm 2.20:

Returns
  The type of the window.

## ◆ gobj() [1/2]

GtkWindow* Gtk::Window::gobj | ( |  | ) |
| inline

Provides access to the underlying C GtkObject.

## ◆ gobj() [2/2]

const GtkWindow* Gtk::Window::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GtkObject.

## ◆ iconify()

void Gtk::Window::iconify | ( |  | ) |

Asks to iconify (i.e. minimize) the specified window.

Note that you shouldn't assume the window is definitely iconified afterward, because other entities (e.g. the user or window manager) could deiconify it again, or there may not be a window manager in which case iconification isn't possible, etc. But normally the window will end up iconified. Just don't write code that crashes if not.

It's permitted to call this function before showing a window, in which case the window will be iconified before it ever appears onscreen.

You can track iconification via the "window-state-event" signal on Gtk::Widget.

## ◆ is_popup()

bool Gtk::Window::is_popup | ( |  | ) | const

Deprecated:
  Use get_window_type().

## ◆ is_toplevel()

bool Gtk::Window::is_toplevel | ( |  | ) | const

Deprecated:
  Use Gtk::Widget::is_toplevel().

## ◆ list_toplevels()

static Glib::ListHandle<Window*> Gtk::Window::list_toplevels | ( |  | ) |
| static

Returns a list of all existing toplevel windows.

The widgets in the list are not individually referenced. If you want to iterate through the list and perform actions involving callbacks that might destroy the widgets, you must call `g_list_foreach (result, (GFunc)g_object_ref, `nullptr`)` first, and then unref all the widgets afterwards.

Returns
  List of toplevel widgets.

## ◆ maximize()

void Gtk::Window::maximize | ( |  | ) |

Asks to maximize window, so that it becomes full-screen.

Note that you shouldn't assume the window is definitely maximized afterward, because other entities (e.g. the user or window manager) could unmaximize it again, and not all window managers support maximization. But normally the window will end up maximized. Just don't write code that crashes if not.

It's permitted to call this function before showing a window, in which case the window will be maximized when it appears onscreen initially.

You can track maximization via the "window-state-event" signal on Gtk::Widget.

## ◆ mnemonic_activate()

bool Gtk::Window::mnemonic_activate | ( | guint | keyval,
|  | Gdk::ModifierType | modifier
| ) |  |

Activates the targets associated with the mnemonic.

Parameters

  keyval | The mnemonic.
  modifier | The modifiers.

Returns
  `true` if the activation is done.

## ◆ move()

void Gtk::Window::move | ( | int | x,
|  | int | y
| ) |  |

Asks the window manager to move window to the given position.

Window managers are free to ignore this; most window managers ignore requests for initial window positions (instead using a user-defined placement algorithm) and honor requests after the window has already been shown.

Note
  the position is the position of the gravity-determined reference point for the window. The gravity determines two things: first, the location of the reference point in root window coordinates; and second, which point on the window is positioned at the reference point.

By default the gravity is Gdk::GRAVITY_NORTH_WEST, so the reference point is simply the x, y supplied to move(). The top-left corner of the window decorations (aka window frame or border) will be placed at x, y. Therefore, to position a window at the top left of the screen, you want to use the default gravity (which is Gdk::GRAVITY_NORTH_WEST) and move the window to 0,0.

To position a window at the bottom right corner of the screen, you would set Gdk::GRAVITY_SOUTH_EAST, which means that the reference point is at x + the window width and y + the window height, and the bottom-right corner of the window border will be placed at that reference point. So, to place a window in the bottom right corner you would first set gravity to south east, then write: `gtk_window_move (window, gdk_screen_width() - window_width, gdk_screen_height() - window_height)` (note that this example does not take multi-head scenarios into account).

The Extended Window Manager Hints specification at http://www.freedesktop.org/Standards/wm-spec has a nice table of gravities in the "implementation notes" section.

The get_position() documentation may also be relevant.

Parameters

  x | X coordinate to move window to.
  y | Y coordinate to move window to.

## ◆ on_frame_event()

virtual bool Gtk::Window::on_frame_event | ( | GdkEvent * | event | ) |
| protectedvirtual

This is a default handler for the signal signal_frame_event().

## ◆ on_set_focus()

virtual void Gtk::Window::on_set_focus | ( | Widget* | focus | ) |
| protectedvirtual

This is a default handler for the signal signal_set_focus().

## ◆ parse_geometry()

bool Gtk::Window::parse_geometry | ( | const Glib::ustring & | geometry | ) |

Parses a standard X Window System geometry string - see the manual page for X (type 'man X') for details on this.

parse_geometry() does work on all GTK+ ports including Win32 but is primarily intended for an X environment.

If either a size or a position can be extracted from the geometry string, parse_geometry() returns `true` and calls set_default_size() and/or move() to resize/move the window.

If parse_geometry() returns `true`, it will also set the Gdk::HINT_USER_POS and/or Gdk::HINT_USER_SIZE hints indicating to the window manager that the size/position of the window was user-specified. This causes most window managers to honor the geometry.

Note that for parse_geometry() to work as expected, it has to be called when the window has its "final" size, i.e. after calling Gtk::Widget::show_all() on the contents and set_geometry_hints() on the window.

[C example ellipted]

Parameters

  geometry | Geometry string.

Returns
  `true` if string was parsed successfully.

## ◆ present() [1/2]

void Gtk::Window::present | ( |  | ) |

Presents a window to the user.

This may mean raising the window in the stacking order, deiconifying it, moving it to the current desktop, and/or giving it the keyboard focus, possibly dependent on the user's platform, window manager, and preferences.

If window is hidden, this function calls Gtk::Widget::show() as well.

This function should be used when the user tries to open a window that's already open. Say for example the preferences dialog is currently open, and the user chooses Preferences from the menu a second time; use present() to move the already-open dialog where the user can see it.

If you are calling this function in response to a user interaction, it is preferable to use present_with_time().

## ◆ present() [2/2]

void Gtk::Window::present | ( | guint32 | timestamp | ) |

Presents a window to the user in response to a user interaction.

If you need to present a window without a timestamp, use present(). See present() for details.

Since gtkmm 2.8:

Parameters

  timestamp | The timestamp of the user interaction (typically a button or key press event) which triggered this call.

## ◆ property_accept_focus() [1/2]

Glib::PropertyProxy< bool > Gtk::Window::property_accept_focus | ( |  | ) |

TRUE if the window should receive the input focus.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_accept_focus() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::Window::property_accept_focus | ( |  | ) | const

TRUE if the window should receive the input focus.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_allow_grow() [1/2]

Glib::PropertyProxy< bool > Gtk::Window::property_allow_grow | ( |  | ) |

If TRUE, users can expand the window beyond its minimum size.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_allow_grow() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::Window::property_allow_grow | ( |  | ) | const

If TRUE, users can expand the window beyond its minimum size.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_allow_shrink() [1/2]

Glib::PropertyProxy< bool > Gtk::Window::property_allow_shrink | ( |  | ) |

If TRUE, the window has no mimimum size.

Setting this to TRUE is 99% of the time a bad idea.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_allow_shrink() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::Window::property_allow_shrink | ( |  | ) | const

If TRUE, the window has no mimimum size.

Setting this to TRUE is 99% of the time a bad idea.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_decorated() [1/2]

Glib::PropertyProxy< bool > Gtk::Window::property_decorated | ( |  | ) |

Whether the window should be decorated by the window manager.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_decorated() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::Window::property_decorated | ( |  | ) | const

Whether the window should be decorated by the window manager.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_default_height() [1/2]

Glib::PropertyProxy< int > Gtk::Window::property_default_height | ( |  | ) |

The default height of the window, used when initially showing the window.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_default_height() [2/2]

Glib::PropertyProxy_ReadOnly< int > Gtk::Window::property_default_height | ( |  | ) | const

The default height of the window, used when initially showing the window.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_default_width() [1/2]

Glib::PropertyProxy< int > Gtk::Window::property_default_width | ( |  | ) |

The default width of the window, used when initially showing the window.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_default_width() [2/2]

Glib::PropertyProxy_ReadOnly< int > Gtk::Window::property_default_width | ( |  | ) | const

The default width of the window, used when initially showing the window.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_deletable() [1/2]

Glib::PropertyProxy< bool > Gtk::Window::property_deletable | ( |  | ) |

Whether the window frame should have a close button.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_deletable() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::Window::property_deletable | ( |  | ) | const

Whether the window frame should have a close button.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_destroy_with_parent() [1/2]

Glib::PropertyProxy< bool > Gtk::Window::property_destroy_with_parent | ( |  | ) |

If this window should be destroyed when the parent is destroyed.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_destroy_with_parent() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::Window::property_destroy_with_parent | ( |  | ) | const

If this window should be destroyed when the parent is destroyed.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_focus_on_map() [1/2]

Glib::PropertyProxy< bool > Gtk::Window::property_focus_on_map | ( |  | ) |

TRUE if the window should receive the input focus when mapped.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_focus_on_map() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::Window::property_focus_on_map | ( |  | ) | const

TRUE if the window should receive the input focus when mapped.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_gravity() [1/2]

Glib::PropertyProxy< Gdk::Gravity > Gtk::Window::property_gravity | ( |  | ) |

The window gravity of the window.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_gravity() [2/2]

Glib::PropertyProxy_ReadOnly< Gdk::Gravity > Gtk::Window::property_gravity | ( |  | ) | const

The window gravity of the window.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_has_toplevel_focus()

Glib::PropertyProxy_ReadOnly< bool > Gtk::Window::property_has_toplevel_focus | ( |  | ) | const

Whether the input focus is within this GtkWindow.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_icon() [1/2]

Glib::PropertyProxy< Glib::RefPtr<Gdk::Pixbuf> > Gtk::Window::property_icon | ( |  | ) |

Icon for this window.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_icon() [2/2]

Glib::PropertyProxy_ReadOnly< Glib::RefPtr<Gdk::Pixbuf> > Gtk::Window::property_icon | ( |  | ) | const

Icon for this window.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_icon_name() [1/2]

Glib::PropertyProxy< Glib::ustring > Gtk::Window::property_icon_name | ( |  | ) |

Name of the themed icon for this window.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_icon_name() [2/2]

Glib::PropertyProxy_ReadOnly< Glib::ustring > Gtk::Window::property_icon_name | ( |  | ) | const

Name of the themed icon for this window.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_is_active()

Glib::PropertyProxy_ReadOnly< bool > Gtk::Window::property_is_active | ( |  | ) | const

Whether the toplevel is the current active window.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_mnemonics_visible() [1/2]

Glib::PropertyProxy< bool > Gtk::Window::property_mnemonics_visible | ( |  | ) |

Whether mnemonics are currently visible in this window.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_mnemonics_visible() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::Window::property_mnemonics_visible | ( |  | ) | const

Whether mnemonics are currently visible in this window.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_modal() [1/2]

Glib::PropertyProxy< bool > Gtk::Window::property_modal | ( |  | ) |

If TRUE, the window is modal (other windows are not usable while this one is up).

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_modal() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::Window::property_modal | ( |  | ) | const

If TRUE, the window is modal (other windows are not usable while this one is up).

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_opacity() [1/2]

Glib::PropertyProxy< double > Gtk::Window::property_opacity | ( |  | ) |

The opacity of the window, from 0 to 1.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_opacity() [2/2]

Glib::PropertyProxy_ReadOnly< double > Gtk::Window::property_opacity | ( |  | ) | const

The opacity of the window, from 0 to 1.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_resizable() [1/2]

Glib::PropertyProxy< bool > Gtk::Window::property_resizable | ( |  | ) |

If TRUE, users can resize the window.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_resizable() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::Window::property_resizable | ( |  | ) | const

If TRUE, users can resize the window.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_role() [1/2]

Glib::PropertyProxy< Glib::ustring > Gtk::Window::property_role | ( |  | ) |

Unique identifier for the window to be used when restoring a session.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_role() [2/2]

Glib::PropertyProxy_ReadOnly< Glib::ustring > Gtk::Window::property_role | ( |  | ) | const

Unique identifier for the window to be used when restoring a session.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_screen() [1/2]

Glib::PropertyProxy< Glib::RefPtr<Gdk::Screen> > Gtk::Window::property_screen | ( |  | ) |

The screen where this window will be displayed.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_screen() [2/2]

Glib::PropertyProxy_ReadOnly< Glib::RefPtr<Gdk::Screen> > Gtk::Window::property_screen | ( |  | ) | const

The screen where this window will be displayed.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_skip_pager_hint() [1/2]

Glib::PropertyProxy< bool > Gtk::Window::property_skip_pager_hint | ( |  | ) |

TRUE if the window should not be in the pager.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_skip_pager_hint() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::Window::property_skip_pager_hint | ( |  | ) | const

TRUE if the window should not be in the pager.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_skip_taskbar_hint() [1/2]

Glib::PropertyProxy< bool > Gtk::Window::property_skip_taskbar_hint | ( |  | ) |

TRUE if the window should not be in the task bar.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_skip_taskbar_hint() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::Window::property_skip_taskbar_hint | ( |  | ) | const

TRUE if the window should not be in the task bar.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_startup_id()

Glib::PropertyProxy_WriteOnly< Glib::ustring > Gtk::Window::property_startup_id | ( |  | ) |

Unique startup identifier for the window used by startup-notification.

Returns
  A PropertyProxy_WriteOnly that allows you to set the value of the property, or receive notification when the value of the property changes.

## ◆ property_title() [1/2]

Glib::PropertyProxy< Glib::ustring > Gtk::Window::property_title | ( |  | ) |

The title of the window.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_title() [2/2]

Glib::PropertyProxy_ReadOnly< Glib::ustring > Gtk::Window::property_title | ( |  | ) | const

The title of the window.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_transient_for() [1/2]

Glib::PropertyProxy< Window* > Gtk::Window::property_transient_for | ( |  | ) |

The transient parent of the dialog.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_transient_for() [2/2]

Glib::PropertyProxy_ReadOnly< Window* > Gtk::Window::property_transient_for | ( |  | ) | const

The transient parent of the dialog.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_type()

Glib::PropertyProxy_ReadOnly< WindowType > Gtk::Window::property_type | ( |  | ) | const

The type of the window.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_type_hint() [1/2]

Glib::PropertyProxy< GdkWindowTypeHint > Gtk::Window::property_type_hint | ( |  | ) |

Hint to help the desktop environment understand what kind of window this is and how to treat it.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_type_hint() [2/2]

Glib::PropertyProxy_ReadOnly< GdkWindowTypeHint > Gtk::Window::property_type_hint | ( |  | ) | const

Hint to help the desktop environment understand what kind of window this is and how to treat it.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_urgency_hint() [1/2]

Glib::PropertyProxy< bool > Gtk::Window::property_urgency_hint | ( |  | ) |

TRUE if the window should be brought to the user's attention.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_urgency_hint() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::Window::property_urgency_hint | ( |  | ) | const

TRUE if the window should be brought to the user's attention.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_window_position() [1/2]

Glib::PropertyProxy< WindowPosition > Gtk::Window::property_window_position | ( |  | ) |

The initial position of the window.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_window_position() [2/2]

Glib::PropertyProxy_ReadOnly< WindowPosition > Gtk::Window::property_window_position | ( |  | ) | const

The initial position of the window.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ raise()

virtual void Gtk::Window::raise | ( |  | ) |
| virtual

Brings the window to the front.

This is just a more obvious convenience wrapper for get_window()->raise().

## ◆ remove_accel_group()

void Gtk::Window::remove_accel_group | ( | const Glib::RefPtr< AccelGroup >& | accel_group | ) |

Reverses the effects of add_accel_group().

Parameters

  accel_group | A Gtk::AccelGroup.

## ◆ remove_mnemonic()

void Gtk::Window::remove_mnemonic | ( | guint | keyval,
|  | Widget& | target
| ) |  |

Removes a mnemonic from this window.

Parameters

  keyval | The mnemonic.
  target | The widget that gets activated by the mnemonic.

## ◆ reshow_with_initial_size()

void Gtk::Window::reshow_with_initial_size | ( |  | ) |

Hides window, then reshows it, resetting the default size and position of the window.

Used by GUI builders only.

## ◆ resize()

void Gtk::Window::resize | ( | int | width,
|  | int | height
| ) |  |

Resizes the window as if the user had done so, obeying geometry constraints.

The default geometry constraint is that windows may not be smaller than their size request; to override this constraint, call Gtk::Widget::set_size_request() to set the window's request to a smaller value.

If resize() is called before showing a window for the first time, it overrides any default size set with set_default_size().

Windows may not be resized smaller than 1 by 1 pixels.

Parameters

  width | Width in pixels to resize the window to.
  height | Height in pixels to resize the window to.

## ◆ set_accept_focus()

void Gtk::Window::set_accept_focus | ( | bool | setting = `true` | ) |

Windows may set a hint asking the desktop environment not to receive the input focus.

This function sets this hint.

Since gtkmm 2.4:

Parameters

  setting | `true` to let this window receive input focus.

## ◆ set_auto_startup_notification()

static void Gtk::Window::set_auto_startup_notification | ( | bool | setting = `true` | ) |
| static

By default, after showing the first Gtk::Window, GTK+ calls gdk_notify_startup_complete().

Call this function to disable the automatic startup notification. You might do this if your first window is a splash screen, and you want to delay notification until after your real main window has been shown, for example.

In that example, you would disable startup notification temporarily, show your splash screen, then re-enable it so that showing the main window would automatically result in notification.

Since gtkmm 2.2:

Parameters

  setting | `true` to automatically do startup notification.

## ◆ set_decorated()

void Gtk::Window::set_decorated | ( | bool | setting = `true` | ) |

By default, windows are decorated with a title bar, resize controls, etc.

Some window managers allow GTK+ to disable these decorations, creating a borderless window. If you set the decorated property to `false` using this function, GTK+ will do its best to convince the window manager not to decorate the window. Depending on the system, this function may not have any effect when called on a window that is already visible, so you should call it before calling gtk_window_show().

On Windows, this function always works, since there's no window manager policy involved.

Parameters

  setting | `true` to decorate the window.

## ◆ set_default()

void Gtk::Window::set_default | ( | Gtk::Widget& | default_widget | ) |

The default widget is the widget that's activated when the user presses Enter in a dialog (for example).

This function sets the default widget for a Gtk::Window. When setting (rather than unsetting) the default widget it's generally easier to call Gtk::Widget::grab_focus() on the widget. Before making a widget the default widget, you must set the Gtk::CAN_DEFAULT flag on the widget you'd like to make the default using GTK_WIDGET_SET_FLAGS().

Parameters

  default_widget | Widget to be the default.

## ◆ set_default_icon()

static void Gtk::Window::set_default_icon | ( | const Glib::RefPtr< Gdk::Pixbuf >& | icon | ) |
| static

Sets an icon to be used as fallback for windows that haven't had set_icon() called on them from a pixbuf.

Since gtkmm 2.4:

Parameters

  icon | The icon.

## ◆ set_default_icon_from_file()

static bool Gtk::Window::set_default_icon_from_file | ( | const std::string & | filename | ) |
| static

Sets an icon to be used as fallback for windows that haven't had set_icon_list() called on them from a file on disk.

Warns on failure if err is `nullptr`.

Since gtkmm 2.2:

Parameters

  filename | Location of icon file.

Returns
  `true` if setting the icon succeeded.

## ◆ set_default_icon_list()

static void Gtk::Window::set_default_icon_list | ( | const Glib::ListHandle< Glib::RefPtr< Gdk::Pixbuf > >& | list | ) |
| static

Sets an icon list to be used as fallback for windows that haven't had set_icon_list() called on them to set up a window-specific icon list.

This function allows you to set up the icon for all windows in your app at once.

See set_icon_list() for more details.

Parameters

  list | A list of Gdk::Pixbuf.

## ◆ set_default_icon_name()

static void Gtk::Window::set_default_icon_name | ( | const Glib::ustring & | name | ) |
| static

Sets an icon to be used as fallback for windows that haven't had set_icon_list() called on them from a named themed icon, see set_icon_name().

Since gtkmm 2.6:

Parameters

  name | The name of the themed icon.

## ◆ set_default_size()

void Gtk::Window::set_default_size | ( | int | width,
|  | int | height
| ) |  |

Sets the default size of a window.

If the window's "natural" size (its size request) is larger than the default, the default will be ignored. More generally, if the default size does not obey the geometry hints for the window (set_geometry_hints() can be used to set these explicitly), the default size will be clamped to the nearest permitted size.

Unlike Gtk::Widget::set_size_request(), which sets a size request for a widget and thus would keep users from shrinking the window, this function only sets the initial size, just as if the user had resized the window themselves. Users can still shrink the window again as they normally would. Setting a default size of -1 means to use the "natural" default size (the size request of the window).

For more control over a window's initial size and how resizing works, investigate set_geometry_hints().

For some uses, resize() is a more appropriate function. resize() changes the current size of the window, rather than the size to be used on initial display. resize() always affects the window itself, not the geometry widget.

The default size of a window only affects the first time a window is shown; if a window is hidden and re-shown, it will remember the size it had prior to hiding, rather than using the default size.

Windows can't actually be 0x0 in size, they must be at least 1x1, but passing 0 for width and height is OK, resulting in a 1x1 default size.

Parameters

  width | Width in pixels, or -1 to unset the default width.
  height | Height in pixels, or -1 to unset the default height.

## ◆ set_deletable()

void Gtk::Window::set_deletable | ( | bool | setting = `true` | ) |

By default, windows have a close button in the window frame.

Some window managers allow GTK+ to disable this button. If you set the deletable property to `false` using this function, GTK+ will do its best to convince the window manager not to show a close button. Depending on the system, this function may not have any effect when called on a window that is already visible, so you should call it before calling gtk_window_show().

On Windows, this function always works, since there's no window manager policy involved.

Since gtkmm 2.10:

Parameters

  setting | `true` to decorate the window as deletable.

## ◆ set_focus()

void Gtk::Window::set_focus | ( | Gtk::Widget& | focus | ) |

If focus is not the current focus widget, and is focusable, sets it as the focus widget for the window.

To set the focus to a particular widget in the toplevel, it is usually more convenient to use Gtk::Widget::grab_focus() instead of this function.

Parameters

  focus | Widget to be the new focus widget.

## ◆ set_focus_on_map()

void Gtk::Window::set_focus_on_map | ( | bool | setting = `true` | ) |

Windows may set a hint asking the desktop environment not to receive the input focus when the window is mapped.

This function sets this hint.

Since gtkmm 2.6:

Parameters

  setting | `true` to let this window receive input focus on map.

## ◆ set_frame_dimensions()

void Gtk::Window::set_frame_dimensions | ( | int | left,
|  | int | top,
|  | int | right,
|  | int | bottom
| ) |  |

(Note: this is a special-purpose function intended for the framebuffer port; see set_has_frame().

It will have no effect on the window border drawn by the window manager, which is the normal case when using the X Window system.)

For windows with frames (see set_has_frame()) this function can be used to change the size of the frame border.

Deprecated: 2.24: This function will be removed in GTK+ 3

Parameters

  left | The width of the left border.
  top | The height of the top border.
  right | The width of the right border.
  bottom | The height of the bottom border.

## ◆ set_geometry_hints()

void Gtk::Window::set_geometry_hints | ( | Widget& | geometry_widget,
|  | const Gdk::Geometry& | geometry,
|  | Gdk::WindowHints | geom_mask
| ) |  |

This function sets up hints about how a window can be resized by the user.

You can set a minimum and maximum size; allowed resize increments (e.g. for xterm, you can only resize by the size of a character); aspect ratios; and more. See the Gdk::Geometry struct.

Parameters

  geometry_widget | Widget the geometry hints will be applied to.
  geometry | Struct containing geometry information.
  geom_mask | Mask indicating which struct fields should be paid attention to.

## ◆ set_gravity()

void Gtk::Window::set_gravity | ( | Gdk::Gravity | gravity | ) |

Window gravity defines the meaning of coordinates passed to move().

See move() and Gdk::Gravity for more details.

The default window gravity is Gdk::GRAVITY_NORTH_WEST which will typically "do what you mean."

Parameters

  gravity | Window gravity.

## ◆ set_has_frame()

void Gtk::Window::set_has_frame | ( | bool | setting = `true` | ) |

(Note: this is a special-purpose function for the framebuffer port, that causes GTK+ to draw its own window border.

For most applications, you want set_decorated() instead, which tells the window manager whether to draw the window border.)

If this function is called on a window with setting of `true`, before it is realized or showed, it will have a "frame" window around window->window, accessible in window->frame. Using the signal frame_event you can receive all events targeted at the frame.

This function is used by the linux-fb port to implement managed windows, but it could conceivably be used by X-programs that want to do their own window decorations.

Deprecated: 2.24: This function will be removed in GTK+ 3

Parameters

  setting | A boolean.

## ◆ set_icon()

void Gtk::Window::set_icon | ( | const Glib::RefPtr< Gdk::Pixbuf >& | icon | ) |

Sets up the icon representing a Gtk::Window.

This icon is used when the window is minimized (also known as iconified). Some window managers or desktop environments may also place it in the window frame, or display it in other contexts.

The icon should be provided in whatever size it was naturally drawn; that is, don't scale the image before passing it to GTK+. Scaling is postponed until the last minute, when the desired final size is known, to allow best quality.

If you have your icon hand-drawn in multiple sizes, use set_icon_list(). Then the best size will be used.

This function is equivalent to calling set_icon_list() with a 1-element list.

See also set_default_icon_list() to set the icon for all windows in your application in one go.

Parameters

  icon | Icon image, or `nullptr`.

## ◆ set_icon_from_file()

bool Gtk::Window::set_icon_from_file | ( | const std::string & | filename | ) |

Sets the icon for the window.

This function is equivalent to calling set_icon() with a pixbuf created by loading the image from filename.

Parameters

  filename | Location of icon file.

Returns
  `true` if setting the icon succeeded.

## ◆ set_icon_list()

void Gtk::Window::set_icon_list | ( | const Glib::ListHandle< Glib::RefPtr< Gdk::Pixbuf > >& | list | ) |

Sets up the icon representing a Gtk::Window.

The icon is used when the window is minimized (also known as iconified). Some window managers or desktop environments may also place it in the window frame, or display it in other contexts.

set_icon_list() allows you to pass in the same icon in several hand-drawn sizes. The list should contain the natural sizes your icon is available in; that is, don't scale the image before passing it to GTK+. Scaling is postponed until the last minute, when the desired final size is known, to allow best quality.

By passing several sizes, you may improve the final image quality of the icon, by reducing or eliminating automatic image scaling.

Recommended sizes to provide: 16x16, 32x32, 48x48 at minimum, and larger images (64x64, 128x128) if you have them.

See also set_default_icon_list() to set the icon for all windows in your application in one go.

Note that transient windows (those who have been set transient for another window using set_transient_for()) will inherit their icon from their transient parent. So there's no need to explicitly set the icon on transient windows.

Parameters

  list | List of Gdk::Pixbuf.

## ◆ set_icon_name()

void Gtk::Window::set_icon_name | ( | const Glib::ustring & | name | ) |

Sets the icon for the window from a named themed icon.

See the docs for Gtk::IconTheme for more details.

Note that this has nothing to do with the WM_ICON_NAME property which is mentioned in the ICCCM.

Since gtkmm 2.6:

Parameters

  name | The name of the themed icon.

## ◆ set_keep_above()

void Gtk::Window::set_keep_above | ( | bool | setting = `true` | ) |

Asks to keep window above, so that it stays on top.

Note that you shouldn't assume the window is definitely above afterward, because other entities (e.g. the user or window manager) could not keep it above, and not all window managers support keeping windows above. But normally the window will end kept above. Just don't write code that crashes if not.

It's permitted to call this function before showing a window, in which case the window will be kept above when it appears onscreen initially.

You can track the above state via the "window-state-event" signal on Gtk::Widget.

Note that, according to the Extended Window Manager Hints specification, the above state is mainly meant for user preferences and should not be used by applications e.g. for drawing attention to their dialogs.

Since gtkmm 2.4:

Parameters

  setting | Whether to keep window above other windows.

## ◆ set_keep_below()

void Gtk::Window::set_keep_below | ( | bool | setting = `true` | ) |

Asks to keep window below, so that it stays in bottom.

Note that you shouldn't assume the window is definitely below afterward, because other entities (e.g. the user or window manager) could not keep it below, and not all window managers support putting windows below. But normally the window will be kept below. Just don't write code that crashes if not.

It's permitted to call this function before showing a window, in which case the window will be kept below when it appears onscreen initially.

You can track the below state via the "window-state-event" signal on Gtk::Widget.

Note that, according to the Extended Window Manager Hints specification, the above state is mainly meant for user preferences and should not be used by applications e.g. for drawing attention to their dialogs.

Since gtkmm 2.4:

Parameters

  setting | Whether to keep window below other windows.

## ◆ set_manage()

virtual void Gtk::Window::set_manage | ( |  | ) |
| virtual

Overriden to warn that it doesn't make sense to use Gtk::manage() on this class because it has no parent container.

## ◆ set_mnemonic_modifier()

void Gtk::Window::set_mnemonic_modifier | ( | Gdk::ModifierType | modifier | ) |

Sets the mnemonic modifier for this window.

Parameters

  modifier | The modifier mask used to activate mnemonics on this window.

## ◆ set_mnemonics_visible()

void Gtk::Window::set_mnemonics_visible | ( | bool | setting = `true` | ) |

Sets the Gtk::Window::property_mnemonics_visible() property.

Since gtkmm 2.20:

Parameters

  setting | The new value.

## ◆ set_modal()

void Gtk::Window::set_modal | ( | bool | modal = `true` | ) |

Sets a window modal or non-modal.

Modal windows prevent interaction with other windows in the same application. To keep modal dialogs on top of main application windows, use set_transient_for() to make the dialog transient for the parent; most window managers will then disallow lowering the dialog below the parent.

Parameters

  modal | Whether the window is modal.

## ◆ set_opacity()

void Gtk::Window::set_opacity | ( | double | opacity | ) |

Request the windowing system to make window partially transparent, with opacity 0 being fully transparent and 1 fully opaque.

(Values of the opacity parameter are clamped to the [0,1] range.) On X11 this has any effect only on X screens with a compositing manager running. See Gtk::Widget::is_composited(). On Windows it should work always.

Note that setting a window's opacity after the window has been shown causes it to flicker once on Windows.

Since gtkmm 2.12:

Parameters

  opacity | Desired opacity, between 0 and 1.

## ◆ set_position()

void Gtk::Window::set_position | ( | WindowPosition | position | ) |

Sets a position constraint for this window.

If the old or new constraint is Gtk::WIN_POS_CENTER_ALWAYS, this will also cause the window to be repositioned to satisfy the new constraint.

Parameters

  position | A position constraint.

## ◆ set_resizable()

void Gtk::Window::set_resizable | ( | bool | resizable = `true` | ) |

Sets whether the user can resize a window.

Windows are user resizable by default.

Parameters

  resizable | `true` if the user can resize this window.

## ◆ set_role()

void Gtk::Window::set_role | ( | const Glib::ustring & | role | ) |

This function is only useful on X11, not with other GTK+ targets.

In combination with the window title, the window role allows a window manager to identify "the same" window when an application is restarted. So for example you might set the "toolbox" role on your app's toolbox window, so that when the user restarts their session, the window manager can put the toolbox back in the same place.

If a window already has a unique title, you don't need to set the role, since the WM can use the title to identify the window when restoring the session.

Parameters

  role | Unique identifier for the window to be used when restoring a session.

## ◆ set_screen()

void Gtk::Window::set_screen | ( | const Glib::RefPtr< Gdk::Screen >& | screen | ) |

Sets the Gdk::Screen where the window is displayed; if the window is already mapped, it will be unmapped, and then remapped on the new screen.

Since gtkmm 2.2:

Parameters

  screen | A Gdk::Screen.

## ◆ set_skip_pager_hint()

void Gtk::Window::set_skip_pager_hint | ( | bool | setting = `true` | ) |

Windows may set a hint asking the desktop environment not to display the window in the pager.

This function sets this hint. (A "pager" is any desktop navigation tool such as a workspace switcher that displays a thumbnail representation of the windows on the screen.)

Since gtkmm 2.2:

Parameters

  setting | `true` to keep this window from appearing in the pager.

## ◆ set_skip_taskbar_hint()

void Gtk::Window::set_skip_taskbar_hint | ( | bool | setting = `true` | ) |

Windows may set a hint asking the desktop environment not to display the window in the task bar.

This function sets this hint.

Since gtkmm 2.2:

Parameters

  setting | `true` to keep this window from appearing in the task bar.

## ◆ set_title()

void Gtk::Window::set_title | ( | const Glib::ustring & | title | ) |

Sets the title of the Gtk::Window.

The title of a window will be displayed in its title bar; on the X Window System, the title bar is rendered by the window manager, so exactly how the title appears to users may vary according to a user's exact configuration. The title should help a user distinguish this window from other windows they may have open. A good title might include the application name and current document filename, for example.

Parameters

  title | Title of the window.

## ◆ set_transient_for()

void Gtk::Window::set_transient_for | ( | Window& | parent | ) |

Dialog windows should be set transient for the main application window they were spawned from.

This allows window managers to e.g. keep the dialog on top of the main window, or center the dialog over the main window. Gtk::Dialog::new_with_buttons() and other convenience functions in GTK+ will sometimes call set_transient_for() on your behalf.

Passing `nullptr` for parent unsets the current transient window.

On Windows, this function puts the child window on top of the parent, much as the window manager would have done on X.

Parameters

  parent | Parent window, or `nullptr`.

## ◆ set_type_hint()

void Gtk::Window::set_type_hint | ( | Gdk::WindowTypeHint | hint | ) |

By setting the type hint for the window, you allow the window manager to decorate and handle the window in a way which is suitable to the function of the window in your application.

This function should be called before the window becomes visible.

Gtk::Dialog::new_with_buttons() and other convenience functions in GTK+ will sometimes call set_type_hint() on your behalf.

Parameters

  hint | The window type.

## ◆ set_urgency_hint()

void Gtk::Window::set_urgency_hint | ( | bool | setting = `true` | ) |

Windows may set a hint asking the desktop environment to draw the users attention to the window.

This function sets this hint.

Since gtkmm 2.8:

Parameters

  setting | `true` to mark this window as urgent.

## ◆ set_wmclass()

void Gtk::Window::set_wmclass | ( | const Glib::ustring & | wmclass_name,
|  | const Glib::ustring & | wmclass_class
| ) |  |

Don't use this function.

It sets the X Window System "class" and "name" hints for a window. According to the ICCCM, you should always set these to the same value for all windows in an application, and GTK+ sets them to that value by default, so calling this function is sort of pointless. However, you may want to call set_role() on each window in your application, for the benefit of the session manager. Setting the role allows the window manager to restore window positions when loading a saved session.

Parameters

  wmclass_name | Window name hint.
  wmclass_class | Window class hint.

## ◆ signal_frame_event()

Glib::SignalProxy< bool,GdkEvent* > Gtk::Window::signal_frame_event | ( |  | ) |

Slot Prototype:
  `bool on_my_frame_event(GdkEvent* event)`

## ◆ signal_set_focus()

Glib::SignalProxy< void,Widget* > Gtk::Window::signal_set_focus | ( |  | ) |

Slot Prototype:
  `void on_my_set_focus(Widget* focus)`

## ◆ stick()

void Gtk::Window::stick | ( |  | ) |

Asks to stick window, which means that it will appear on all user desktops.

Note that you shouldn't assume the window is definitely stuck afterward, because other entities (e.g. the user or window manager) could unstick it again, and some window managers do not support sticking windows. But normally the window will end up stuck. Just don't write code that crashes if not.

It's permitted to call this function before showing a window.

You can track stickiness via the "window-state-event" signal on Gtk::Widget.

## ◆ unfullscreen()

void Gtk::Window::unfullscreen | ( |  | ) |

Asks to toggle off the fullscreen state for window.

Note that you shouldn't assume the window is definitely not full screen afterward, because other entities (e.g. the user or window manager) could fullscreen it again, and not all window managers honor requests to unfullscreen windows. But normally the window will end up restored to its normal state. Just don't write code that crashes if not.

You can track the fullscreen state via the "window-state-event" signal on Gtk::Widget.

Since gtkmm 2.2:

## ◆ unmaximize()

void Gtk::Window::unmaximize | ( |  | ) |

Asks to unmaximize window.

Note that you shouldn't assume the window is definitely unmaximized afterward, because other entities (e.g. the user or window manager) could maximize it again, and not all window managers honor requests to unmaximize. But normally the window will end up unmaximized. Just don't write code that crashes if not.

You can track maximization via the "window-state-event" signal on Gtk::Widget.

## ◆ unset_default()

void Gtk::Window::unset_default | ( |  | ) |

## ◆ unset_focus()

void Gtk::Window::unset_focus | ( |  | ) |

## ◆ unset_transient_for()

void Gtk::Window::unset_transient_for | ( |  | ) |

Unsets the current transient window.

See also
  set_transient_for().

Since gtkmm 2.20:

## ◆ unstick()

void Gtk::Window::unstick | ( |  | ) |

Asks to unstick window, which means that it will appear on only one of the user's desktops.

Note that you shouldn't assume the window is definitely unstuck afterward, because other entities (e.g. the user or window manager) could stick it again. But normally the window will end up stuck. Just don't write code that crashes if not.

You can track stickiness via the "window-state-event" signal on Gtk::Widget.

## Friends And Related Function Documentation

## ◆ wrap()

Gtk::Window* wrap | ( | GtkWindow * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.

The documentation for this class was generated from the following file:

- gtkmm/window.h